define("io.ox/office/editframework/app/editapplication",["io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/api/tab","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/forms","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/worker/intervalrunner","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/utils/seleniumlogger","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/app/acquireeditrightsworker","io.ox/office/editframework/view/editlabels","gettext!io.ox/office/editframework/main"],function(e,t,n,i,r,o,a,s,l,c,u,d,f,g,p,E,h,O,I,S,m,N,R,A,D,v,y,C,T,w,b,U,F){"use strict";function L(e){var t=B(e,"operations",[]);return t.every(_.isObject)?t:(Q.error("EditApplication.getOperationsFromData(): invalid elements in operations array",t),[])}function G(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:U.RELOAD_ICON,label:U.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:U.EDIT_ICON,label:U.EDIT_LABEL};break;case"loadrestored":e.action={itemKey:"document/reload",icon:U.LOAD_RESTORED_ICON,label:U.LOAD_RESTORED_LABEL};break;default:delete e.action}}function x(e,t,n){var i=M();e.done(function(e){i.resolve(e)}),e.fail(function(e){i.reject(e)});var r=window.setTimeout(function(){i.reject("timeout"),Q.warn(n+" - operation timed out")},t);return e.always(function(){window.clearTimeout(r)}),i.promise()}var k=r.isFiniteNumber,P=r.getNumber,B=r.getArray,M=r.newDeferred,H=r.newFulfilled,q=r.newRejected,j=r.toPromise,V=o.stringEndsWith,W=o.trimAndCleanString,z=o.capitalizeFirst,Y=o.filterArray,K=s.FILTER_MODULE_NAME,Z=s.requireOptModule,Q=l.globalLogger,J=l.getFormattedLogBuffer,X=v.SaveAsType,ee=v.STORAGE_AVAILABLE,te=v.RENAME_DISABLED,ne=v.TRANSFER_EDIT_RIGHTS_TIMEOUT,ie=d.IntervalRunner,re=f.MessageDialog,oe=N.FlushReason,ae=C.otLogger,se=C.cleanupRemovedOperations,le=b.acquireEditLogger,ce=b.AcquireEditRightsWorker,ue={ACCEPT:"accept",DECLINE:"decline",INACTIVE:"inactive"},de=30,fe=-1,ge=F("unnamed"),pe=8e3,Ee=2e3,he=5e3,Oe=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","serverOSN"];return N.extend(function(r,o,s){function l(e){var t={};return Oe.forEach(function(n){n in e&&(t[n]=e[n])}),t}function d(e,t){var n=St.getState();St.setRootAttribute("data-app-state",n),St.trigger("docs:state",n,e,t),St.trigger("docs:state:"+n,t),le.log("statechange",n,e)}function f(e){var t=nn?"error":In?"preview":Wt?en||!Yt?"readonly":rt()?"sending":Kt?"ready":"initial":"offline";if(Vt!==t){var n=Vt;Vt=t,d(n,e)}}function C(e){Yt!==e&&(Yt=e,St.trigger("docs:editmode",Yt),le.log("$back(LightPink)changeEditMode",Yt),St.trigger(Yt?"docs:editmode:enter":"docs:editmode:leave"),f())}function b(e,t){if("load"===e.action&&_.isObject(e.file)){var n=e.file.id+"_"+e.file.folder_id,i=n+"_OSN",r=n+"_FILEVERSION",o=n+"_STORAGEVERSION",a=localStorage.getItem(i),s=localStorage.getItem(r);localStorage.getItem(o)>=cn&&a&&s&&(a=parseInt(a,10),s=parseInt(s,10),_.isNumber(a)&&_.isNumber(s)&&(t.storageOSN=a,t.storageVersion=s))}}function U(){return{documentFileLockedByUser:tn,fullFileName:St.getFullFileName(),oldEditUser:zt,isEditor:We()}}function M(e,t){var n=F("Read-Only Mode"),i=null,r=null,o=null;_.isString(e)?(r={type:"info",message:e,headline:n},isNaN(t)||(r.duration=t),r=_.extend({},r,{action:"acquireedit"})):(o=U(),i=St.getErrorState(),r=qn,_.isObject(r)||(_.isObject(i)&&(i.isError()||i.isWarning())?r=I.getMessageData(i,o):(i=St.getInfoState(),_.isString(i)&&(r=S.getMessageData(i,o))))),St.extendMessageData(r),Nt.yell(r)}function _e(e){var t=_.findWhere(hn,{clientUID:e});return t&&t.userName||""}function Ie(){function e(){kn=!0}St.getUserSettingsValue("showToolbars",!0)?Nt.getToolBarTabs().one("tab:activated",e):St.waitForImportSuccess(e)}function Se(e){var t=g.isErrorCode(e)?e:me(e);if(t.setErrorContext(p.CONNECTION),st()){var n=yt.hasPendingActions()||St.hasUnsavedChangesOffice();en=!0,C(!1),n?Mt?St.setInternalError(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,p.CONNECTION):St.restoreDocument(t):(o.action="load",delete o.template,St.reloadDocument())}else St.setInternalError(t,p.CONNECTION)}function me(e){var t;switch(e){case"reset":t=new g(h.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new g(h.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new g(h.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}function Ne(){on=!0,Wt&&!nn&&!St.isInQuit()&&st()&&(rn=Yt,Wt=!1,Mt&&Kn.abort(),Rn?yt.hasPendingActions()?St.setInternalError(h.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,p.OFFLINE):St.setInternalError(h.ERROR_OFFLINE_WHILE_SYNCHRONIZING,p.OFFLINE):(en=!0,C(!1),f(),St.setInternalError(h.WARNING_READONLY_DUE_TO_OFFLINE,p.OFFLINE)),T.log("Connection offline handler called by Realtime!"),xe())}function Re(){!on||Wt||nn||St.isInQuit()||(T.log("Connection online handler called by Realtime!"),Mt&&Kn.start(),Wt=!0,Nn&&(Mt?Ae():De()),f(),M())}function Ae(){T.log("Client supports synchronization - starting to sync with server"),_.isObject(St)&&(rn?(St.setInternalError(h.WARNING_SYNC_AFTER_OFFLINE,p.SYNCHRONIZATION),T.log("Client is editor - synchronizing with server using current client state"),Rn="editSync",Ct&&Ct.length>0&&ai()):(St.setInternalError(h.WARNING_SYNC_FOR_VIEWER,p.SYNCHRONIZATION),T.log("Client is viewer - waiting for server messages to unlock view"),Rn="viewSync"),St.executeDelayed(function(){!An&&Rn&&(T.log("Synchronization time out detected - no synchronization possible"),qe({cause:"timeout"}))},"EditApplication.startSynchronizationProcessOT",1e3*de),Rn&&st()&&(yt.sync(),yt.syncStable().then(function(e){T.log("SyncStable response received ",e),qe(e&&e.docStatus?null:{cause:"reset"})},function(){qe({cause:"reset"})}).done(function(){St.repeatDelayed(function(){return!Rn||An?i.BREAK:st()?void qe(null):(qe({cause:"reset"}),i.BREAK)},"EditApplication.startSynchronizationProcessOT",{delay:0,repeatDelay:1e3*de/10,cycles:9})})))}function De(){if(T.log("Client supports synchronization - starting to sync with server"),_.isObject(St)&&(rn?(St.setInternalError(h.WARNING_SYNC_AFTER_OFFLINE,p.SYNCHRONIZATION),T.log("Client is editor - synchronizing with server using current client state"),Rn="editSync",Ct&&Ct.length>0&&ai()):(St.setInternalError(h.WARNING_SYNC_FOR_VIEWER,p.SYNCHRONIZATION),T.log("Client is viewer - waiting for server messages to unlock view"),Rn="viewSync"),St.executeDelayed(function(){!An&&Rn&&(T.log("Synchronization time out detected - no synchronization possible"),je(null,null,null,{cause:"timeout"}))},"EditApplication.startSynchronizationProcess",1e3*de),Rn&&st())){var e=-1,t=null,n=yt.sync().then(function(n){if(T.log("Sync response received ",n),n&&n.docStatus){var r=mt.getOperationStateNumber();return t=i.getStringOption(n.docStatus,"editUserId",""),e=i.getIntegerOption(n.docStatus,"serverOSN",-1),an=t,je(t,r,e,null),$.when()}throw new Error("sync response contains no mandatory data - synchronization impossible!")},function(){je(null,null,null,{cause:"reset"})});(n=n.then(function(){if(Rn&&st()){var n=yt.syncStable();return n.done(function(n){if(T.log("SyncStable response received ",n),n&&n.docStatus){var r=mt.getOperationStateNumber();t=i.getStringOption(n.docStatus,"editUserId",""),an=t,je(t,r,e,null)}else je(null,null,null,{cause:"reset"})}),n.fail(function(){je(null,null,null,{cause:"reset"})}),n}throw je(null,null,null,{cause:"reset"}),new Error("synchronization not possible")},function(){je(null,null,null,{cause:"reset"})})).done(function(){St.repeatDelayed(function(){if(!Rn||!st())return je(null,null,null,{cause:"reset"}),i.BREAK;var n=mt.getOperationStateNumber();je(_.isString(t)?t:an,n,e,null)},"EditApplication.startSynchronizationProcess",{delay:0,repeatDelay:1e3*de/10,cycles:9})})}}function ve(e,t){var n;T.log("Error handler called by RT2 communication layer, cause = "+JSON.stringify(e)),t&&"pending"===t.state()&&t.reject(e),_.isObject(e)&&_.isString(e.error)&&(n=new g(e)),St&&("GENERAL_SESSION_INVALID_ERROR"===n.getCodeAsConstant()?ye(n):"GENERAL_DOCUMENT_ALREADY_DISPOSED_ERROR"===n.getCodeAsConstant()?_.isString(Rn)?(An=!0,Mt?qe({cause:"error:disposed"}):je(null,null,null,{cause:"error:disposed"})):St.setInternalError(n,p.CONNECTION):"TOO_MANY_CONNECTIONS_ERROR"===n.getCodeAsConstant()?(An=!0,Rn=null,St.setInternalError(n,p.CONNECTION)):St.isLocked()||St.isInQuit()||_.isString(Rn)?_.isString(Rn)&&(An=!0,Mt?qe({cause:"reset"}):je(null,null,null,{cause:"reset"})):"HANGUP_INVALID_OPERATIONS_SENT_ERROR"===e.error||"HANGUP_INVALID_OSN_DETECTED_ERROR"===e.error?St.setInternalError(e,p.CONNECTION):"HANGUP_NO_EDIT_RIGHTS_ERROR"===e.error?St.restoreDocument(n):(n=h.ERROR_UNKNOWN_REALTIME_FAILURE,St.setInternalError(e,p.CONNECTION)))}function ye(e){function t(){ox.off("relogin:success",t),ox.off("relogin:fail",n),i=!1,Mt?Ae():De(),Vn=!1}function n(){ox.off("relogin:success",t),ox.off("relogin:fail",n),St.setInternalError(e),Vn=!1}if(!Vn){Vn=!0;var i=!0;St.setInternalError(h.WARNING_SESSION_INVALID_DETECTED,p.CONNECTION),en=!0,C(!1),f(),ox.on("relogin:success",t),ox.on("relogin:fail",n),St.executeDelayed(function(){i&&(i=!1,ox.trigger("relogin:required"))},"EditApplication.connectionErrorHandler",5e3)}}function Ce(){T.log("NoResponseInTime notification received - Server has not responded in a certain time"),St.isLocked()||St.isInQuit()||St.setInternalError(h.WARNING_CONNECTION_INSTABLE)}function Te(){if(T.log("Shutdown notification received - Document middleware node is going down!"),!St.isLocked()&&!St.isInQuit()&&st()){var e=yt.hasPendingActions()||St.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};Yt&&e?St.setInternalError(h.ERROR_SERVER_SHUTDOWN_NO_RESCUE_POSSIBLE,p.CONNECTION,null,t):St.setInternalError(h.ERROR_SERVER_GOING_TO_SHUTDOWN,p.CONNECTION,null,t)}}function we(){if(T.log("Crashed node notification received - Document middleware node is not available anymore!"),!St.isLocked()&&!St.isInQuit()&&st()){var e=yt.hasPendingActions()||St.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}};Yt&&e?St.setInternalError(h.ERROR_SERVER_NODE_UNAVAILABLE_NO_RESCUE_POSSIBLE,p.CONNECTION,null,t):St.setInternalError(h.ERROR_SERVER_NODE_UNAVAILABLE,p.CONNECTION,null,t)}}function be(e,t){if(T.log("Hangup notification received - document cannot be edited anymore!"),!St.isLocked()&&!St.isInQuit()&&st()){var n=yt.hasPendingActions()||St.hasUnsavedChanges(),i=new g(t);i.isError()||(i=new g(h.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),We()&&(n||Ue(i))?Mt?St.setInternalError(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,p.CONNECTION):St.restoreDocument(i):St.setInternalError(i,p.CONNECTION)}}function Ue(e){var t=!1;if(g.isErrorCode(e)&&e.isError())switch(e.getCodeAsConstant()){case"SAVEDOCUMENT_FILE_HAS_CHANGED_ERROR":case"GENERAL_FILE_NOT_FOUND_ERROR":case"GENERAL_PERMISSION_READ_MISSING_ERROR":case"GENERAL_PERMISSION_WRITE_MISSING_ERROR":case"LOADDOCUMENT_CANNOT_RETRIEVE_OPERATIONS_ERROR":t=!0}return t}function Fe(e,t){if(!St.isInQuit())if(new g(t).isError())Fn&&Fn.reject(t);else{var n=i.getStringOption(t,"fileId",null),r=i.getStringOption(t,"fileName",null);n&&r?(Fn&&Fn.resolve(t),St.updateFileDescriptor({id:n,filename:r,title:u.getFileBaseName(r)}),o.action="load",delete o.template,Kt=!1,St.reloadDocument()):Fn&&Fn.reject(t)}}function Le(e){St.hasUnsavedChangesOffice()?St.executeDelayed(function(){Le(e)},"EditApplication.checkForPendingOperations",2e3):ai().then(function(){st()&&yt.canLoseEditRights(e),sn=!1,St.getController().update(),T.log("sent canLoseEditRights")})}function Ge(e){if(le.log("$back(lightgreen)handleEditRequestViaUpdate",e),!St.isInQuit()&&null===Rn&&an===At){var t=e&&_.isArray(e.activeUsers)?_.find(e.activeUsers,function(e){return e&&e.clientUID!==At&&e.requestsEditRights}):null,n=t?t.clientUID:null;if(n){if(le.log("$back(lightgreen)__handleEditRequestViaUpdate - clientUIDRequesting ",Bn,_e(n)),Bn)return le.log("$back(lightgreen)__handleEditRequestViaUpdate - BLOCK OTHER REQUESTS?",n),void(Bn.clientUID!==n&&st()&&(le.log("$back(lightgreen)__handleEditRequestViaUpdate - REQUEST BLOCKED!"),yt.declineEditRights(n)));le.log("$back(lightgreen)__handleEditRequestViaUpdate - Request edit rights",Ut);var i=Be(n);i.done(function(e){if(le.log("$back(lightgreen)__handleEditRequestViaUpdate - answer: "+e),e===ue.DECLINE)return le.log("$back(lightgreen)__handleEditRequestViaUpdate - EditRights transfer declined"),void(st()&&yt.declineEditRights(n));le.log("$back(lightgreen)__handleEditRequestViaUpdate - EditRights transfer accepted"),sn=!0,C(!1),St.setCurrentInfoState(O.INFO_PREPARE_LOSING_EDIT_RIGHTS,{showMessage:e===ue.INACTIVE}),f(),St.getController().update();var t=s&&s.prepareLoseEditRightsHandler;(t?j(t.bind(St)):H()).always(function(){T.log("handle PrepareLosingEditRights"),St.executeDelayed(function(){Le(n)},"EditApplication.handlePrepareLosingEditRights",1e3)})}),i.fail(function(e){le.log("$back(lightgreen)__handleEditRequestViaUpdate - EditRights transfer failure, reason:",e)})}}}function xe(){Pn.abort(),le.log("$back(SandyBrown)abortPendingEditRightsRequest")}function ke(){Bn&&(Bn.promise.abort(),le.log("abortPendingEditRightsTransfer"))}function Pe(){var e=Ut>0,t=null,n=_.now()-Mn;return le.log("inactivCheck knownWhenLastOpWasSend",e),e?(t=Date.now()-Ut,le.log("inactivCheck sendActionsTime",Ut,t)):(t=Date.now()-Sn,le.log("inactivCheck importFinishedTime",Sn,t)),le.log("inactivCheck User is inactive?",t>12e4,!i.wasKeyPressedWithinTime(12e4),"timeDeltaToLastTransfer",n,n>12e4),t>12e4&&!i.wasKeyPressedWithinTime(12e4)&&n>12e4}function Be(e){if(le.log("$back(MediumAquaMarine)handleEditRightsTransferRequest"),Pe())return H(ue.INACTIVE);var t=St.newDeferred("EditApplication.handleEditRightsTransferRequest"),n=St.createAbortablePromise(t);Bn={deferred:t,promise:n,clientUID:e},le.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest - callForUserInput"),Nt.yell({type:"question",message:F("%1$s is asking for edit rights. This request will be accepted automatically in %2$d seconds.",_.noI18n(_e(e)),Math.floor(ne/1e3)),duration:ne,progress:!0,disableCloser:!0,restoreHidden:!0,priority:!0,renderFn:function(e){var n=$.button({label:F("Decline")}).addClass("btn-default").css({marginRight:5});n.on("click tab",function(){le.log("$back(Orchid)__handleEditRightsTransferRequest - DECLINE BUTTON PRESSED BY USER"),Mn=Date.now(),le.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest -> DECISION: declined"),t.resolve(ue.DECLINE)});var i=$.button({label:F("Accept")}).addClass("btn-primary");i.on("click tab",function(){le.log("$back(Orchid)__handleEditRightsTransferRequest - ACCEPT BUTTON PRESSED BY USER"),le.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest -> DECISION: accepted"),t.resolve(ue.ACCEPT)});var r=$('<div class="button-area" style="text-align:center;margin-top:10px;">');e.append(r.append(n,i))}});var i=St.executeDelayed(function(){le.log("$back(MediumAquaMarine)__handleEditRightsTransferRequest - DECISION: accepted automatically"),t.resolve(ue.ACCEPT)},"EditApplication.handleEditRightsTransferRequest.autoAcceptTimer",{delay:ne,background:!0});return n.always(function(){Bn=null,i.abort(),Nt&&Nt.hideYell({priority:!0})}),n}function Me(e){le.log("$back(lightblue)applyEditState - DOC UPDATE",e);var t=Mt?null:i.getStringOption(e,"editUserId",""),n=Mt?null:_e(t),r=Mt?null:n||e.editUser,o=Mt?null:Yt,a=Mt?null:o,s=St.getFileDescriptor(),l=mt.getOperationStateNumber(),c=Mt?null:i.getIntegerOption(e,"serverOSN",-1),d=new g(e),E=i.getIntegerOption(e,"lockedByUserId",fe),I=i.getBooleanOption(e,"writeProtected",null),S=i.getBooleanOption(e,"rescueDoc",null);if(Mt?T.log("applyEditState: clientOSN = "+l):T.log("applyEditState: clientOSN = "+l+", localServerOSN = "+c),!nn&&Oe.some(function(t){return t in e})){if(Mt||t===an||(T.log("Edit rights changed, new editing user id: "+t),a=At===t,St.setCurrentInfoState(O.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1}),le.log("$back(lightblue)__applyEditState - EDITOR HAS BEEN CHANGED","|editClientId:",t,"|oldEditClientId:",an),Pn.running&&""!==t&&(le.log("$back(lightblue)__applyEditState - FORCE TIMER ABORTED the editor has been changed"),xe())),i.getBooleanOption(e,"failSafeSaveDone",!1)&&u.propagateChangeFile(s),i.getBooleanOption(e,"hasErrors",!1))return St.setInternalError(h.ERROR_GENERAL_SYNCHRONIZATION_ERROR,p.SYNCHRONIZATION),void T.error("synchronization to the server has been lost.");en||(v.RESCUE_DOCUMENT_READONLY&&_.isBoolean(S)&&S?(en=!0,C(!1),St.setInternalError(h.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,p.READONLY)):_.isBoolean(I)&&I?(en=!0,C(!1),St.setInternalError(h.WARNING_NO_PERMISSION_FOR_DOC,p.READONLY)):E!==fe&&ox.user_id!==E&&(en=!0,C(!1),St.setInternalError(h.WARNING_DOC_IS_LOCKED,p.READONLY),tn=i.getStringOption(e,"lockedByUser",""))),en||sn||(Mt?C(!0):(T.log("Edit mode: "+a),C(a),!a&&(!Wt||o||r!==zt&&r.length)&&(zt=r,St.setCurrentInfoState(O.INFO_USER_IS_CURRENTLY_EDIT_DOC)),Wt&&t&&t!==an&&(He(t),zt=r),a&&!1===o&&St.setCurrentInfoState(O.INFO_EDITRIGHTS_RECEIVED),Wt&&!a&&o&&-1!==c&&l>c&&(St.setInternalError(h.ERROR_GENERAL_SYNCHRONIZATION_ERROR,p.SYNCHRONIZATION),T.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+a+"Old edit mode: "+o+", local Server OSN: "+c+", Client OSN: "+l))),(d.isError()||d.isWarning())&&St.setInternalError(d,p.GENERAL)),Wt=!0,f()}}function He(e){var t=an,n=e,i=[n];_.isString(t)&&t.length>0&&i.push(t),an=n,ri(i)}function qe(e){function t(){T.log("logSynchronizationState... ","\n     localChanges = ",i,"\n     rtConnection.getPendingActions() = ",st()&&JSON.stringify(yt.getPendingActions()),"\n     self.getPendingActions() = ",JSON.stringify(St.getPendingActions()),"\n     mustSyncNowMode = ",Rn,"\n     failedData = ",JSON.stringify(e))}var n=null,i=function(){var e=St.getPendingActions(),t=st()&&yt.getPendingActions();return _.isArray(e)&&e.length>0||_.isObject(t)&&_.isArray(t.actions)&&t.actions.length>0}();if(Rn){if(T.log("Checking synchronization state with server"),e){switch(e.cause){case"timeout":T.log("Synchronization not possible - maybe connection instance is gone"),(n=new g(h.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(p.SYNCHRONIZATION),t(),Rn=null;break;case"notMember":case"reset":case"error:disposed":T.log("Synchronization not possible - connection instance is gone or rt-state broken"),(n=new g(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(p.SYNCHRONIZATION),t(),Rn=null}Se(n)}switch(Rn){case"editSync":if(i)return;T.log("Synchronization successfully completed"),en=!1,C(!0),St.setCurrentInfoState(O.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0});break;case"viewSync":T.log("Synchronization for viewer completed"),St.setCurrentInfoState(O.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})}t(),Rn=null}}function je(e,t,n,i){function r(e,t){T.log("logSynchronizationState... ","\n     localChanges = ",a,"\n     rtConnection.getPendingActions() = ",st()&&JSON.stringify(yt.getPendingActions()),"\n     self.getPendingActions() = ",JSON.stringify(St.getPendingActions()),"\n     mustSyncNowMode = ",Rn,"\n     clientOSN = ",e,"\n     serverOSN = ",t,"\n     oldEditUser = ",zt,"\n     failedData = ",JSON.stringify(i))}var o=null,a=function(){var e=St.getPendingActions(),t=st()&&yt.getPendingActions();return _.isArray(e)&&e.length>0||_.isObject(t)&&_.isArray(t.actions)&&t.actions.length>0}();if(Rn){if(T.log("Checking synchronization state with server"),i){switch(i.cause){case"timeout":T.log("Synchronization not possible - maybe connection instance is gone"),(o=new g(h.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(p.SYNCHRONIZATION),r(t,n),Rn=null;break;case"notMember":case"reset":case"error:disposed":T.log("Synchronization not possible - connection instance is gone or rt-state broken"),(o=new g(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(p.SYNCHRONIZATION),r(t,n),Rn=null}Se(o)}switch(Rn){case"editSync":if(We()){if(a)return;T.log("Synchronization successfully completed"),en=!1,C(!0),St.setCurrentInfoState(O.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0})}else a?(T.log("Synchronization not possible - editor changed"),(o=new g(h.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(p.SYNCHRONIZATION),St.restoreDocument(o)):t>=n?(T.log("Synchronization possible - but we lost edit rights"),en=!1,St.setCurrentInfoState(O.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(T.log("Synchronization not possible - did not receive missing operations"),St.reloadDocument());break;case"viewSync":t>=n?(T.log("Synchronization for viewer completed"),en=!1,St.setCurrentInfoState(O.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(T.log("Synchronization not possible - did not receive missing operations"),St.reloadDocument())}r(t,n),Rn=null}}function Ve(e){var t=St.getFileDescriptor(),n=i.getStringOption(e,"fileName",""),r=i.getStringOption(e,"com.openexchange.file.sanitizedFilename",""),o=i.getStringOption(e,"fileVersion",""),a={};n.length>0&&n!==i.getStringOption(t,"filename")&&(a.filename=n),r.length>0&&r!==i.getStringOption(t,"com.openexchange.file.sanitizedFilename")&&(a["com.openexchange.file.sanitizedFilename"]=r),o.length>0&&o!==i.getStringOption(t,"version")&&(a.version=o),nn||_.isEmpty(a)||(St.updateFileDescriptor(a),St.getController().update(),f())}function $e(e,t){var n=null,i=null;return e.length===t.length&&(n=_.copy(e,!0),i=_.copy(t,!0),_.each(n,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(i,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(n,i))}function We(){return Mt||At===an}function ze(e){Ze(e,!0).done(function(){Jn.shift(),Jn.length>0&&ze(Jn[0])})}function Ye(){Mt&&Jn.length>0&&!mt.isProcessingActions()&&ze(Jn[0])}function Ke(e,t){var n;e>Yn?t?e===Yn+1?(Yn=e,Zn=-1):(Zn=e,ae.info("DEBUGGING: Saving OSN from ack temporarily: "+Zn)):(e>Yn+1&&ae.info("Setting server OSN. Info: Increasing OSN by more than 1. Increasing from: "+Yn+" to "+e),n=Yn,Zn===(Yn=e)+1?(ae.info("Updating server OSN with saved ack osn: "+Zn+". Triggering event: docs:ackosn:updated."),Yn=Zn,Zn=-1,St.trigger("docs:ackosn:updated")):Zn>=0&&Yn>Zn&&(ae.error("ERROR: Setting server OSN. Receiving OSN from external operation: "+e+". But still have temporary OSN from acknowledge: "+Zn),ae.error("ERROR: Current locally used server OSN is: "+n),Zn=-1,St.trigger("docs:ackosn:updated"))):ae.info("Setting server OSN. Avoiding to set server OSN to: "+e+". Current OSN is already: "+Yn),ae.info("Setting server OSN to: "+Yn),mt.trigger("change:osn",Yn)}function Ze(e,t){if(nn)return T.error("EditApplication.applyRemoteOperations(): failed due to internal error"),$.Deferred().reject();var n=Mt?P(e.docStatus,"serverOSN",-1):0;if(n<0)return Q.error("EditApplication.applyRemoteActions(): missing server OSN in external operations"),$.Deferred().reject();var i=L(e);if(0===i.length)return Mt&&Ke(n),$.when();if(y.handleMinifiedActions([{operations:i}],!0),Mt||mt.getUndoManager().clearUndoActions(),T.log("EditApplication.applyRemoteOperations(): last remote operation: "+JSON.stringify(_.last(i))),Mt){if(mt.isProcessingInternalOperations()||Jn.length>0&&!t)return t||Jn.push(e),St.createResolvedPromise({cached:!0});if(ae.info("received external operations with server OSN "+n),Ke(n),zn.length>0){Qn+=i.length,ae.info("DEBUGGING: external operations before:",i),ae.info("DEBUGGING: local operations without ACK before:",zn);try{i=St.getOTManager().transformOperations(i,zn)}catch(e){return ae.exception(e,"operation transformation failed"),$.Deferred().reject({cause:"operation"})}ae.info("DEBUGGING: external operations after:",i),ae.info("DEBUGGING: local operations without ACK after:",zn)}else ae.info("DEBUGGING: external operations not transformed:",i)}var r=mt.applyExternalOperations(i);return r.done(function(){Zt=!0}),r.fail(function(){St&&!St.isInQuit()&&T.error("EditApplication.applyRemoteOperations(): failed")}),r}function Qe(e){if(Mt)return!1;var t=!1,n=mt.getOperationStateNumber();return v.RESTORE_DOCUMENT_ENABLED&&e.length>0&&(t=!("editSync"!==Rn||!st()||!yt.hasPendingActions())||n!==e[0].osn),t}function Je(e){if(!_.isObject(e))return Q.error("EditApplication.registerUpdateMessageData(): invalid response (object expected):",e),this.setInternalError(h.ERROR_WHILE_MODIFYING_DOCUMENT,p.GENERAL),$.Deferred().reject();if(T.log("EditApplication.registerUpdateMessageData(): received update message:",e),_n.length>0&&At!==e.editUserId){T.log(" "+_n.length+' existing pending updates must be changed to user "'+e.editUserId+'"');var t={editUser:e.editUser,editUserId:e.editUserId};_n.forEach(function(e){_.extend(e,t)})}_n.push(e);var n=oi(e);return n.always(function(){_n.shift(),T.log("EditApplication.registerUpdateMessageData(): update processed, "+_n.length+" pending messages left")}),n}function Xe(e,t,n){if(!e)return H();var i=j(e.bind(St)).fail(function(){Q.warn("EditApplication - failed initialization step: "+n)});return i=i.then(function(e){return St.isInQuit()?q({cause:"closing"}):e}),St.launchTracker.asyncStep(i,t,"EditApp: "+n)}function et(){var e=St.createDeferred("EditApplication.establishConnection");return Xe(function(){var t=st()?yt.connect():St.createRejectedPromise();return T.log("Channel UID:",st()?yt.getChannelUID():null),ei=st()?yt.getDocUID():"null",ti=st()?yt.getClientUID():"null",(t=t.then(function(e){if(e.hasErrors||new g(e).isError())throw e;return e})).done(function(t){e.resolve(t)}),t.fail(function(t){e.reject(t)}),e.promise()},"connect","Realtime connection established")}function tt(e){if(_.isObject(St)&&!St.isInQuit()||(e={cause:"quit"}),Dn)return{cause:""};var t=new g(e),n=t.getCodeAsConstant();switch(nn=!0,kt.call(St,e),e=_.clone(e),n){case"GENERAL_FILE_NOT_FOUND_ERROR":Xt=!0}return t.isError()||(t=function(e){return e&&e.error_desc&&e.error_id&&_.isString(e.error_desc)&&_.isString(e.error_id)}(e)?function(e){if(t=new g(g.GENERAL_ERROR),e&&e.error_desc){var n=e.error_desc;t.setDescription(n)}return t}(e):new g(h.ERROR_UNKNOWN_REALTIME_FAILURE)),St.isInQuit()||St.setInternalError(t,p.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:St.isViewerMode()}),Dn=!0,e}function nt(e){return{operations:e||[]}}function it(){return Tt&&Tt.operations&&Tt.operations.length>0}function rt(){return wt||Ct.length>0||it()}function ot(e){Y(zn,function(t){return!t[e]})}function at(e){var t=Nt.processUnsavedComment(e===oe.QUIT);return t=t.then(function(){return Qt}),t=t.then(function(){var t=s&&s.prepareFlushHandler;return t?t.call(St,e):null}),t=t.then(function(){var t=ai();return e===oe.QUIT&&(t=x(t,he,"EditApplication.prepareFlushDocument")),t})}function st(){return!(!yt||yt.destroyed)}function lt(){yt&&(xe(),ke(),yt.destroy(),St.rtConnection=yt=null)}function ct(e,t,n){if(!st())return q();var i=null,r=yt.getConnectOpenState();if(T.log("EditApplication.executeShutdownStep: - silentShutdownEntered:",ut()," connectionOpenState:",r," action:",e),!ut()){var o=!1,a=!1,s=!1;switch(r){case"unknown":case"joining":o=!1,a=!1,s=!1;break;case"joined":o=!1,a=!1,s=!0;break;case"opening":o=!0,a=!1,s=!0;break;case"opened":o=!1,a=!0,s=!0}i=function(){switch(e){case".abortOpen":return o?yt.abortOpen():null;case".closeDocument":return a?yt.closeDocument(t):null;case".disconnect":return s?yt.disconnect(t):null}}()}return ut()&&(i=function(){switch(e){case".closeDocument:force":return yt.closeDocument(t);case".disconnect:force":return yt.disconnect(t)}}()),i?n?x(i,n,'EditApplication.executeShutdownStep("'+e+'")'):i:q()}function ut(){return!(null===jn)}function dt(e){var t=i.getBooleanOption(e,"skipCloseDoc",!1),n=i.getBooleanOption(e,"skipDisconnect",!1);if(T.log("EditApplication.silentShutdownConnection entered! - silentShutdownConfig:",e,"silentShutdownConnectionEntered",ut()),!ut()){en=!0,C(!1),Mt&&Kn.abort();var r=$.Deferred();jn=r.promise(),st()&&yt.off();var o;(o=t?$.when():ct(".closeDocument:force",{no_restore:Hn},500)).always(function(e){var i;if(n)i=$.when();else{var a="timeout"===e,s="rejected"===o.state(),l=a||Boolean(t)||s;T.log("EditApplication.silentShutdownConnection - closeDocument rejected by timeout?:",a),i=ct(".disconnect:force",l,500)}i.always(function(){lt(),T.log("EditApplication.silentShutdownConnection is finished"),r.resolve()})})}}function ft(e){function t(e){d&&Nt.updateBusyProgress(e)}function n(e){function t(){return _.pluck(mt.getSupportedStorageExtensions({allApps:!0}),"extension").concat(g)}var n=localStorage.getItem("appsuiteDocsExpiryDates"),i=_.now();n&&(n=JSON.parse(n),_.isObject(n)?_.each(n,function(r,o){if(o!==e&&i>r){var a=a||t();_.each(a,function(e){var t=o+e;localStorage.removeItem(t)}),delete n[o]}}):n=null),(n=n||{})[e]=i+6048e5,localStorage.setItem("appsuiteDocsExpiryDates",JSON.stringify(n))}function r(){return u.propagateChangeFile(l)}var a=null,s=St.getWindow(),l=St.getFileDescriptor(),d=!1,f=null,g=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],p="logout"===e,E=St.launchTracker;s&&s.busy();var h=Kt||Jt||Zt||Xt,O="new"===o.action||o.template;l&&(h||v.LOG_PERFORMANCE_DATA||!O&&hn.length<=1)&&(f={file:_.extend({last_opened:Date.now()},l),app:St.appType},E.setItem("LocalStorage",gn),E.setItem("FastEmptyLoad",mn),E.sendData());var I=st()&&yt.isConnected()&&!St.isShutdownReceived();return l&&I?(f=Hn?f:_.extend({no_restore:Hn},f),a=c.BROWSER_TAB_SUPPORT?gt(e,f).progress(t):gt(e,f).then(function(e){function t(t){var n=i.getBooleanOption(t,"migration",!1);_.each(g,function(e){localStorage.removeItem(o+e)}),n&&(k(e.syncInfo.fileVersion)?_.each(_.range(e.syncInfo.fileVersion>O?e.syncInfo.fileVersion-O:0,e.syncInfo.fileVersion),function(e){_.each(g,function(t){localStorage.removeItem(o+"_"+e+t)})}):(localStorage.removeItem(o+"_"+e.syncInfo.fileVersion),localStorage.removeItem(o+"_CURRENTVERSION")))}var r=null,o=null,a=null,s=null,l=null,c=null,u=null,f=Kt||Jt||Zt,E=mt.getOperationStateNumber(),h=0,O=20;return ni(),(f||!gn)&&e&&e.syncInfo&&!p&&!St.isDocumentEncrypted()&&ee&&ln&&fn&&_.isFunction(mt.getFullModelDescription)&&e.syncInfo.fileVersion&&e.syncInfo.fileId&&e.syncInfo.folderId&&k(e.syncInfo["document-osn"])&&E===e.syncInfo["document-osn"]&&(n(o=e.syncInfo.fileId+"_"+e.syncInfo.folderId),u=St.newDeferred("EditApplication.saveLocalStorage"),St.executeDelayed(function(){d=!0},"EditApplication.saveFileInStorage",1500),St.executeDelayed(function(){u.notify(.1),r=_.now(),mt.getFullModelDescription(u,.1,.9).always(function(){_.isFunction(mt.getSupportedStorageExtensions)&&_.each(mt.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&g.push(e.extension)}),t({migration:!0})}).done(function(n){function i(e){return t(),Q.info("quitHandler(): "+e),!1}n.every(function(t){var n=t.htmlString,u=o+t.extension,d=null,f=null;Q.info("quitHandler, created document string with size: "+n.length+". Time for conversion: "+(_.now()-r)+" ms.");try{if(0===h){if(a=o+"_OSN",s=o+"_FILEVERSION",l=o+"_STORAGEVERSION",c=o+"_OPERATIONS",localStorage.setItem(a,e.syncInfo["document-osn"]),localStorage.setItem(l,un),localStorage.setItem(s,e.syncInfo.fileVersion),d=mt.getStorageOperationCollector(),_.each(d,function(e){delete e.osn,delete e.opl}),f=JSON.stringify(d),localStorage.setItem(c,f),!localStorage.getItem(c)||localStorage.getItem(c).length!==f.length)return i("failed to save document operations in local storage");Q.info("quitHandler(): successfully saved document operations in local storage with key: "+c)}localStorage.setItem(u,n);var g=localStorage.getItem(u);if(!g||g.length!==n.length)return i("failed to save document in local storage");if(Q.info("quitHandler(): successfully saved document in local storage with key: "+u),0===h){var p=localStorage.getItem(a),E=p?parseInt(p,10):-1;if(E!==e.syncInfo["document-osn"])return i("failed to save OSN for document in local storage");Q.info("quitHandler(): successfully saved OSN for document in local storage with key: "+a+" : "+E)}return h++,!0}catch(e){return i("failed to save document and/or document OSN in local storage")}})}).always(function(){u.notify(1),u.resolve(e)})},"EditApplication.saveFileInStorage")),null===u?e:u.promise()}).progress(t)):a=$.when(),I&&(a=a.then(function(){return v.DEBUG&&St.debugTypeError.test("async-quithandler"),ct(".disconnect",null,Ee)})),l&&(h?a=a.then(r,r):"reload"!==e&&("new"===o.action||o.template)&&hn.length<=1&&!o.keepFile&&(a=a.then(function(){return u.purgeFile(l)}))),a}function gt(e,t){function n(t){var n=St.createDeferred("EditApplication.checkCloseDocumentResult"),o=new g(t),a={},s=null,l=null,c=null,d=null;return o.isError()||o.isWarning()?(s=i.getStringOption(t,E.RESTORED_FILEID,null),l=i.getStringOption(t,E.RESTORED_FILENAME,null),c=i.getStringOption(t,E.RESTORED_FOLDERID,null),d=i.getStringOption(t,E.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(s)&&_.isString(l)&&_.isString(c)?(d=new g(d===g.CONSTANT_NO_ERROR?{errorClass:g.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}:{errorClass:g.ERRORCLASS_ERROR,error:d}),a[E.RESTORED_FILENAME]=l,u.getPath(c).always(function(e){a[E.RESTORED_PATHNAME]=u.preparePath(e),a[E.ORIGINAL_FILEID]=St.getFileDescriptor().id,St.updateFileDescriptor({id:s,folder_id:c}),St.setInternalError(d,p.CLOSE,o,{additionalData:a})})):St.setInternalError(o,p.CLOSE,null,{additionalData:a}),mt&&Nt?(St.registerQuitHandler(function(){n.reject()}),St.quit=function(e){return function(){return n.reject(),e.call(St)}}(St.quit),r.idle(),n.always(function(){r.busy()}),"logout"===e&&n.reject()):n.reject(),o.getDescription()&&Q.log(o.getDescription()),n.promise()):t}var r=St.getWindow();return t=t||null,ct(".closeDocument",t,pe).then(n,function(e){return"timeout"===e?St.createRejectedPromise(e):n(e)})}function pt(e){return Cn[e]}function Et(e){var t=_.indexOf(Tn,e);return t<0&&(t=Tn.length,Tn.push(e)),t}function ht(){ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: clearLocalActionsWithoutAckAfterEvent: Clearing the local actions!"),ae.info("DEBUGGING ***********************************************"),Ot()}function Ot(){mt.isProcessingExternalOperations()?(mt.off("operations:after",ht),ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: clearLocalActionsWithoutAck: External operations are currently applied. Coming back later after event operations:after!"),ae.info("DEBUGGING ***********************************************"),mt.on("operations:after",ht)):Zn>0?(St.off("docs:ackosn:updated",ht),mt.off("operations:after",ht),ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: clearLocalActionsWithoutAck: External operations are still missing. Coming back later after event docs:ackosn:updated or operations:after!"),ae.info("DEBUGGING ***********************************************"),St.on("docs:ackosn:updated",ht),mt.on("operations:after",ht)):(ae.info("DEBUGGING: Clearing local cache. Before: "+JSON.stringify(zn)),mt.off("operations:after",ht),St.off("docs:ackosn:updated",ht),ot("sentToServer"),ae.info("DEBUGGING: Clearing local cache. After: "+JSON.stringify(zn)))}function _t(){ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: sendActionsAfterApplyingExternalOperations: Sending actions after receiving operations:after event!"),ae.info("DEBUGGING ***********************************************"),ai()}function It(){ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: sendActionsAfterReceivingRequiredExternalOperations: Sending actions after receiving docs:ackosn:updated event!"),ae.info("DEBUGGING ***********************************************"),ai()}var St=this,mt=null,Nt=null,Rt=null,At=null,Dt=null,vt=null,yt=null,Ct=[],Tt=null,wt=!1,bt=!1,Ut=0,Ft=i.getFunctionOption(s,"preProcessHandler"),Lt=i.getFunctionOption(s,"postProcessHandler"),Gt=i.getFunctionOption(s,"fastEmptyLoadHandler"),xt=i.getFunctionOption(s,"previewHandler"),kt=i.getFunctionOption(s,"importFailedHandler",_.noop),Pt=i.getFunctionOption(s,"optimizeOperationsHandler"),Bt=i.getFunctionOption(s,"mergeCachedOperationsHandler"),Mt=!(!s||!s.otConfigKey)&&v.getFlag(s.otConfigKey,!1),Ht=Mt?100:i.getNumberOption(s,"sendActionsDelay",0),qt=i.getBooleanOption(s,"isMultiSelectionApp",!0),jt=i.getBooleanOption(s,"isSnapshotApp",!0),Vt=null,$t=null,Wt=!1,zt=null,Yt=null,Kt=!1,Zt=!1,Qt=null,Jt=!1,Xt=!1,en=!1,tn=null,nn=!1,rn=!1,on=!1,an=null,sn=!1,ln=i.getBooleanOption(s,"localStorageApp",!1)&&!Mt,cn=i.getIntegerOption(s,"requiredStorageVersion",0),un=i.getIntegerOption(s,"supportedStorageVersion",0),dn=!1,fn=v.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!o.auth_code,gn=!1,pn={},En=1,hn=[],On=[],_n=[],In=null,Sn=0,mn=!1,Nn=i.getBooleanOption(s,"supportsOnlineSync",!0),Rn=null,An=!1,Dn=!1,vn={},yn="",Cn={},Tn=[],wn=!0,bn=!1,Un=[],Fn=null,Ln=null,Gn=!1,xn=!1,kn=!1,Pn=null,Bn=null,Mn=0,Hn=!0,qn=null,jn=null,Vn=!1,$n="slow load",Wn=!1,zn=[],Yn=0,Kn=null,Zn=-1,Qn=0,Jn=[],Xn={},ei=null,ti=null;N.call(this,r,function(){function e(e,t){U.push(t),T.log("Document status update received during document import")}function t(e,t){G.push(t),T.log("Clients update received during document import")}function n(e){var t={},n=[];return _.each(e,function(e){var i=e.operations;$.extend(t,e),i&&(delete e.operations,n=n.concat(i))}),Xn=t&&t.syncInfo,T.log("loadDocInfo",Xn),t.operations=n,_.isEmpty(t.operations)&&t.syncInfo&&P===parseInt(t.syncInfo["document-osn"],10)&&(x=!0),t}function r(e){var t=0,n=[];return _.each(e,function(e){t=_.isNumber(e.activeSheet)?e.activeSheet:t,n=n.concat(e.operations)}),{preview:{activeSheet:t,operations:n}}}function a(e,t){T.log("Final operation message received for asynchronous load"),Mt&&Ke(t.docStatus.serverOSN),t.hasErrors||"error"===St.getState()?I.reject(t):N.always(function(){O.push(t),I.resolve(n(O))})}function c(e,t){var n=null;if(mn)return delete t.actions,O.length>0?O[0]=_.extend(O[0],t):O.push(t),void N.resolve();if(d(t))return R=!0,void O.push(t);if(R&&!y){y=!0,n=r(O),(O=[]).push(t);var i=E(n);return M.asyncStep(i,"previewProcessing","EditApp: Preview data processed"),i.done(function(){N.resolve()}),void i.fail(function(){N.reject(),tt(t)})}R||"pending"!==N.state()||N.resolve(),O.push(t)}function u(n){function r(n,r){return ri(n).always(function(){Me(n.docStatus)}),Ln=i.getStringOption(n.syncInfo,"restore_id",null),dn=i.getBooleanOption(n.syncInfo,"renameNeedsReload",!1),St.waitForImportSuccess(function(){T.log("Applying clients update messages, count = "+G.length),_.each(G,function(e){ri(e)}),T.log("Applying document update messages, count = "+r.length),_.each(r,function(e){Je(e)}),st()&&(yt.off(D.RESPONSE_OPEN_DOC_CHUNK,c),yt.off(D.RESPONSE_OPEN_DOC,a),yt.off(D.BROADCAST_UPDATE_CLIENTS,t).on(D.BROADCAST_UPDATE_CLIENTS,function(e,t){ri(t)}),yt.off(D.BROADCAST_UPDATE,e).on(D.BROADCAST_UPDATE,function(e,t){Je(t)})),f(),I.resolve({action:[]})}),$.when()}function u(){return St.getUserInfo(ox.user_id).done(function(e){vt=i.escapeHTML(e.operationName)})}var d=L(n),p=l(n.docStatus),E=new g(n),h=null,O=null;return St.isViewerMode()&&(en=!0,Xn={},C(!1)),At=i.getStringOption(n.docStatus,"clientId",""),pn[At]=0,h=function(){var e=null;return i.getBooleanOption(n,"hasErrors",!1)?(Q.error("EditApplication.importHandler - server side error"),e="server"):i.getBooleanOption(n,"operationError",!1)?(Q.error("EditApplication.importHandler - operation failure"),e=n.message):E.isError()?(Q.error("EditApplication.importHandler - server side error, errorCode="+E.getCodeAsConstant()),e="server"):0===At.length?(Q.error("EditApplication.importHandler - missing client identifier"),e="noclientid"):mn||x||_.isArray(d)&&0!==d.length||(Q.error("EditApplication.importHandler - missing document operations"),e="noactions"),e?{cause:e}:null}(),_.isObject(h)?(h=_.extend(h,tt(n)),$.Deferred().reject(h)):function(){function e(){_.each(c,function(e){localStorage.removeItem(i+e.extension)}),localStorage.removeItem(a),localStorage.removeItem(r),localStorage.removeItem(l),localStorage.removeItem(s)}var t=!0,i=null,r=null,a=null,s=null,l=null,c=null;return"load"===o.action&&_.isObject(o.file)?(ee&&ln&&fn&&n.syncInfo&&n.syncInfo.fileVersion&&k(n.syncInfo["document-osn"])&&n.syncInfo.fileId&&n.syncInfo.folderId&&_.isFunction(mt.setFullModelNode)&&_.isFunction(mt.getSupportedStorageExtensions)&&(i=n.syncInfo.fileId+"_"+n.syncInfo.folderId,l=i+"_FILEVERSION",r=i+"_STORAGEVERSION",a=i+"_OSN",s=i+"_OPERATIONS",c=mt.getSupportedStorageExtensions(),(localStorage.getItem(r)&&parseInt(localStorage.getItem(r),10)||1)>=cn?(Q.info("EditApplication.importHandler - document-osn="+n.syncInfo["document-osn"]+", document-rev="+n.syncInfo.fileVersion),localStorage.getItem(l)&&localStorage.getItem(l)===n.syncInfo.fileVersion&&localStorage.getItem(a)&&parseInt(localStorage.getItem(a),10)===parseInt(n.syncInfo["document-osn"],10)?function(){var e=JSON.parse(localStorage.getItem(s));if(!_.isArray(e))return!1;d.length>0&&mt.setExternalLocalStorageOperationsExist(!0),d=e.concat(d);var t=_.last(d);return _.isNumber(t.osn)||(t.opl=1,t.osn=parseInt(localStorage.getItem(a),10)-1),!0}()?c.some(function(t){var n=i+t.extension,r={usedLocalStorage:!0};_.isObject(t.additionalOptions)&&_.extend(r,t.additionalOptions);var o=localStorage.getItem(n);if(o)Q.info("EditApplication.importHandler - loading document from local storage. Key: "+n+" Length: "+localStorage.getItem(n).length),gn=!0,$n="local storage",mt.setFullModelNode(o,r);else{if(!t.optional)return Q.info("EditApplication.importHandler - key in local storage not found. Key: "+n+". But found OSN key: "+a),e(),gn=!1,!0;Q.info("EditApplication.importHandler - optional local storage value not found. Key: "+n)}}):(Q.info("EditApplication.importHandler - required operations in local storage not found. Key: "+s),e()):(Q.info("EditApplication.importHandler - file in local storage not found. Key: "+i),e())):(Q.info("EditApplication.importHandler - version of file in local storage not supported. Key: "+i),e())),gn&&mt.trigger("update:model",{usedLocalStorage:!0}),t):t}()?(function(){var e=null,t="",r=i.getBooleanOption(n,"fastLoad",!1);gn||(!n.htmlDoc&&v.DEBUG&&!mn&&mt.setFullModelNode&&r&&St.getFileDescriptor()&&!V(St.getFileDescriptor().filename,"_ox")&&Nt.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),n.htmlDoc&&_.isFunction(mt.setFullModelNode)&&!mn&&(Q.info("EditApplication.importHandler - load complete HTML document, osn: ",n.syncInfo["document-osn"]),(e=JSON.parse(n.htmlDoc)).mainDocument&&mt.setFullModelNode(e.mainDocument),e.headerFooter&&(_.each(e.headerFooter,function(e){t+=e}),mt.setFullModelNode(t,{headerFooterLayer:!0}),mt.getPageLayout().headerFooterCollectionUpdate()),e.comments&&(t="",_.each(e.comments,function(e){t+=e}),mt.setFullModelNode(t,{commentLayer:!0})),$n="fast load",mt.trigger("fastload:done")))}(),U.unshift({docStatus:p}),mn?($n="fast empty",r(n,U).then(u)):(O=Xe(Ft,"preProcessing","Import preprocess handler finished"),O=O.then(u).then(function(){var e=Xe(function(){var e=s&&s.applyActionsDetached;return e&&Nt.detachAppPane(),mt.applyExternalOperations(d,{expand:!0}).always(function(){e&&Nt&&!Nt.destroyed&&Nt.attachAppPane()})},"applyOperations",d.length+" document operations applied");return e=e.then(function(){var e=null;if(mt.getOperationStateNumber()<0)return $.Deferred().reject({cause:"applyactions",headline:F("Synchronization Error")});var t=gn&&!mt.externalLocalStorageOperationsExist();return e=Xe(Lt?Lt.bind(St,t):null,"postProcessing","Import postprocess handler finished"),e=e.then(function(){return r(n,U)},function(e){return _.extend({cause:"postprocess"},e)})},function(e){if(st()&&yt.off(D.RESPONSE_OPEN_DOC,a),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)}))):$.Deferred().reject({cause:"localStorageFailed",headline:_.noI18n("LocalStorage failure")})}function d(e){return i.getBooleanOption(e,"preview",!1)}function E(e){var t=new g(e),n=i.getObjectOption(e,"preview"),r=t.isError()?$.Deferred().reject(e):$.when();return n&&_.isArray(n.operations)&&(r=function(){var t=Xe(Ft,"previewPreProcessing","Preview preprocess handler finished");return t=t.then(function(){Ft=null;var t=B(e.preview,"operations"),i=t?mt.applyExternalOperations(t,{expand:!0}):St.createResolvedPromise();return M.asyncStep(i,"previewApplyOperations","EditApp: "+t.length+" preview operations applied"),i=i.then(function(){return xt.call(St,n)?St.leaveBusyDuringImport():$.when()},function(t){t&&"abort"===t||(e.operationError=!0,e.message=F("An unrecoverable error occurred while modifying the document."))})}),M.asyncStep(t,"previewEnd","EditApp: Preview postprocess handler finished")}()),r}var O=[],I=St.createDeferred("EditApplication.asynchronousLoadFinished"),S=null,m=null,N=$.Deferred(),R=!1,y=!1,U=[],G=[],x=!1,P=-1,M=St.launchTracker;return mt.getUndoManager().on("undogroup:open",function(){Tt=nt()}),mt.getUndoManager().on("undogroup:close",function(){it()&&si(Tt),Tt=null,Mt&&mt.setInternalOperationBlocker(!1)}),Mt&&mt.getUndoManager().on("undo:after redo:after",function(){mt.setInternalOperationBlocker(!1)}),mt.on("operations:success",function(e,t,n){n||bn||(_.isObject(Tt)?(T.log("operations:success - push operations into pending action"),Tt.operations=Tt.operations.concat(t)):si(nt(t)))}),mt.on("cacheBuffer:flush",function(){T.log("cacheBuffer:flush received - send cached operations"),_.isFunction(Bt)&&Un.length&&(Ct=Bt.call(St,Ct,Un),ai())}),mt.on("operations:error",function(){St.isImportFinished()?(St.setInternalError(h.ERROR_WHILE_MODIFYING_DOCUMENT,p.GENERAL),T.error("An unrecoverable error occurred while modifying the document")):(St.setInternalError(h.ERROR_WHILE_LOADING_DOCUMENT,p.GENERAL),T.error("An unrecoverable error occurred while loading the document"))}),St.getWindowNode().on("drop",!1),yt=St.isViewerMode()?new w(St,s):new T(St),this.rtConnection=yt,mn||Nt.enterBusy({cancelOnReadOnly:!1,cancelHandler:function(){St.isInQuit()||(ct(".abortOpen"),dt(),St.quit())},immediate:!0,topLabel:_.noI18n(St.getFullFileName()),warningLabel:F("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4}),st()&&(yt.on(A.EVENT_OFFLINE,Ne),yt.on(A.EVENT_ONLINE,Re),yt.on(A.EVENT_ERROR,function(e,t){ve(t,I)}),yt.on(A.EVENT_NORESPONSE_IN_TIME,Ce),yt.on(D.BROADCAST_UPDATE,e),yt.on(D.BROADCAST_UPDATE_CLIENTS,t),yt.on(D.BROADCAST_SHUTDOWN,Te),yt.on(D.BROADCAST_CRASHED,we),yt.on(D.BROADCAST_RENAMED_RELOAD,Fe),yt.on(D.BROADCAST_HANGUP,be)),M.step("initImport","EditApp: Import process initializated"),m=et(),ni(),(S=m.then(function(e){var t=new g(e),n={fastEmpty:mn};if(!t.isError())return st()&&(yt.on(D.RESPONSE_OPEN_DOC_CHUNK,c),yt.on(D.RESPONSE_OPEN_DOC,a)),o.auth_code&&(n=_.extend({auth_code:o.auth_code},n)),"new"===o.action&&(n=_.extend({newDoc:!0},n)),mn&&(n=_.extend({fastEmptyOSN:mt.getOperationStateNumber()},n)),ee&&!mn&&fn&&(b(o,n),P=n.storageOSN),st()&&yt.open(n),I.then(u,function(e){return q(tt(e))});tt(e)}).catch(function(e){return q(tt(e))})).always(function(){In=null,f()}),S},o,_.extend({},s,{initHandler:function(){var e=mt.getFontCollection().importReplacementFonts();return v.DEBUG&&(e=e.then(function(){return Z("io.ox/office/debug/common/main",function(e){return e.initializeApp(St)})})),e},initFileHandler:function(){function e(e){return St.setInternalError(e,p.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}if(!St||!o)return Q.warn("EditApplication.initFileHandler() called on an already destroyed instance."),$.Deferred().reject();var t={},n=!1,r=St.launchTracker;switch(o.cryptoAction&&(t.cryptoAction=o.cryptoAction),o.decrypt_auth_code&&(t.cryptoAuth=o.decrypt_auth_code,t.encrypted_file=!0),i.getStringOption(o,"action","load")){case"load":return u.getFile(o.file).done(function(e){o.file=e});case"convert":n=!0;break;case"new":s&&s.newDocumentParams&&_.extend(t,s.newDocumentParams);break;default:return Q.error("EditApplication.initFileHandler(): unsupported launch action"),$.Deferred().reject()}var a=i.getObjectOption(o,"templateFile"),l=i.getBooleanOption(o,"preserveFileName",!1),c=i.getStringOption(o,"target_filename",ge),d=i.getStringOption(o,"target_folder_id",""),f=i.getObjectOption(a,"origin");_.extend(t,{action:"createdefaultdocument",document_type:St.appType,target_filename:c,target_folder_id:d,preserve_filename:l,convert:n}),o.template&&_.extend(t,{action:"createfromtemplate",file_id:a.id}),_.isObject(a)&&_.extend(t,{file_id:a.id,version:a.version}),St.waitForImportSuccess(function(){var e=St.getFileDescriptor(),t=!o.template&&d!==e.folder_id;(o.template?e.converted:n)?St.setCurrentInfoState(t?O.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:O.INFO_DOC_CONVERTED_AND_STORED):t&&St.setCurrentInfoState(O.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});var E=_.url.hash("fields"),h=_.url.hash("fields-source");(E||h)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),t.fields=E,t.sourcefields=h);var I=St.sendRequest(K,t);return I=I.then(function(t){var n=new g(t);return n.isError()?e(n):t},function(){return e()}),r.asyncStep(I,"createNewDocAfterRequest","EditApp: New file in remote storage created"),I=I.then(function(e){return u.getFile(e.file).then(function(t){return e.file=t,e})}),(I=I.then(function(e){function t(e,t){var n=St.isPresentationApp()?St.createResolvedPromise():St.leaveBusyDuringImport(!e,{immediateShow:!0});return r.asyncStep(n,"afterLeaveBusyEarly","EditApp: Busy state after creation of document left"),n.then(function(){if(e)return t;throw t},function(n){throw e?n:t})}return _.isObject(e.file)?(f&&(e.file.origin=f),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(mn=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&e.operations.length>0)&&Gt?Gt.call(St,e.htmlDoc,e.operations).then(t.bind(null,!0),t.bind(null,!1)).then(function(){return e}):e):(Q.error("EditApplication.initFileHandler(): missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:function(e){if(nn)return q();var t=at(e);return t=t.then(function(){return st()?yt.flushDocument():q()})},messageDataHandler:G,printOptionsHandler:function(){return st()?{doc_uid:yt.getDocUID(),client_uid:yt.getClientUID()}:null}}));var ni=v.DEBUG?function(){fn=St.getUserSettingsValue("debugUseLocalStorage",fn)&&!St.isDocumentEncrypted()}:$.noop,ii=v.LOG_PERFORMANCE_DATA?function(){var e=Nt.getToolBarTabs(),t=0;e.on("tab:activated",function n(i,r){if(t++,r){var o="tabActivated_"+z(r);St.launchTracker.step(o,'EditApp: Toolbar tab "'+r+'" activated')}2===t&&e.off("tab:activated",n)})}:$.noop;this.getServerModuleDocUrl=function(e,t,n){if(!st()||!ox.session||!this.hasFileDescriptor())return null;var i=this.getFileParameters(_.extend({},n,{encodeUrl:!0}));return t=_.extend({session:ox.session,uid:this.get("uniqueID"),docuid:yt.getDocUID()},i,t),ox.apiRoot+"/"+e+"?"+_.map(t,function(e,t){return t+"="+e}).join("&")};var ri=this.createSynchronizedMethod("EditApplication.applyUserData",function(e){le.log("$back(PaleGoldenRod)applyUserData - CLIENT UPDATE",e);var t=null;if(_.isArray(e)?(t={clients:{changed:[]}},_.each(e,function(e){t.clients.changed.push({clientUID:e})})):t=e,!_.isObject(t))return Q.error("applyUserData called without valid data: "+JSON.stringify(t)),$.when();var n=On,r=i.getObjectOption(t,"clients",{}),o=[],a=[];if(an===At&&_.isArray(r.changed)&&r.changed.length>0&&Ge({activeUsers:r.changed}),_.isArray(r.list))a=r.list;else if(_.isArray(r.left)||_.isArray(r.joined)||_.isArray(r.changed)){var s={};On.forEach(function(e){s[e.clientUID]=e}),_.isArray(r.left)&&r.left.forEach(function(e){delete s[e]}),_.isArray(r.joined)&&r.joined.forEach(function(e){s[e.clientUID]=e}),_.isArray(r.changed)&&r.changed.forEach(function(e){s[e.clientUID]=_.extend({},s[e.clientUID],e)}),Object.keys(s).forEach(function(e){a.push(s[e])})}return 0===a.length?$.when():(_.each(a,function(e){var t=_.isObject(e)&&_.isString(e.clientUID),n=t&&!_.isNumber(e.userId)&&_.isNumber(e.id);t?n?o.push(St.getUserInfo(e.id).then(function(t){return e.userDisplayName=t.displayName,e.userOperationName=t.operationName,e})):o.push($.when(e)):Q.warn("EditApplication.applyUserData(): missing identifier")}),St.createResolvedPromise().then(function(){return $.when.apply($,o)}).done(function(){if(hn=_.map(arguments,function(e){var t=e;return _.isNumber(e.userId)||((t={}).clientUID=e.clientUID,t.userId=e.id,t.userName=e.userDisplayName,t.userOperationName=e.userOperationName,t.guest=e.guest),t.active=!0===e.active||_.isNumber(e.durationOfInactivity)&&e.durationOfInactivity<60,t.remote=At!==t.clientUID,t.editor=an===t.clientUID,_.isObject(e.userData)&&(t.userData=e.userData),t.clientUID in pn||(pn[t.clientUID]=En,En+=1),t.clientIndex=pn[t.clientUID],t.colorIndex=St.getAuthorColorIndex(t.userOperationName),t}),On=_.where(hn,{active:!0}),On=_.sortBy(On,"clientIndex"),!_.isEqual(n,On)){Q.info("EditApplication.applyUserData(): activeClients=",On),$e(n,On)||St.trigger("docs:users",On),Bn&&!_.findWhere(On,{clientUID:Bn.clientUID})&&ke();var e=_.first(_.pluck(_.where(n,{clientUID:At}),"requestsEditRights")),t=_.first(_.pluck(_.where(On,{clientUID:At}),"requestsEditRights"));!0===e&&!1===t&&(le.log("$back(PaleGoldenRod)__applyUserData - REQUEST_EDITRIGHTS FOR USER -> is false - > event spinner off",e,t,an!==At),xe(),an!==At?(le.log("$back(PaleGoldenRod)__applyUserData - YOUR REQUEST WAS DECLINED"),Nt.yell({message:F("Your request for edit rights has been declined.")})):Mn=_.now()),St.trigger("docs:users:selection",On)}}))}),oi=this.createSynchronizedMethod("EditApplication.applyUpdateMessageData",function(e){if(Qe(L(e)))return Mt?St.setInternalError(h.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,p.CONNECTION):St.restoreDocument(new g(h.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)),$.when();var t=Ze(e);return t.done(function(t){_.isObject(e)&&!_.isObject(e.docStatus)&&Q.error("broadcast_update sent bad data "+JSON.stringify(e)),Mt&&t&&t.cached||(Me(e.docStatus),Ve(e))}),t}),ai=function(){function e(){if(v.REALTIME_DEBUGGING&&sn&&Ct&&Ct.length>0){var n=Ct[Ct.length-1].operations;n&&n.length>0&&Q.log("EditApplication.sendActionsBuffer(): last action:",_.last(n))}if(Mt&&Wn)return St.executeDelayed(function(){e()},"sendActionsBuffer",1e3),void t.resolve();if(Pt){var i=Mt?Ct.length:0;Ct=Pt.call(St,Ct),Mt&&Ct.length!==i&&ot("_OPTIMIZED_OPERATION_")}Ct=y.handleMinifiedActions(Ct);var r=null;Mt?(zn.forEach(function(e){e.sentToServer=!0}),ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING Sending action with operation base OSN: "+Yn),ae.info("DEBUGGING Sending actions: "+JSON.stringify(Ct)),ae.info("DEBUGGING ***********************************************"),r=st()?yt.sendActions(Ct,!1,Yn):St.createRejectedPromise()):r=st()?yt.sendActions(Ct):St.createRejectedPromise(),r.done(function(n){if(Mt){ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: Receiving acknowledge with new OSN sent from server: "+n.body.serverOSN),Ke(n.body.serverOSN,!0),ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: Trying to clear local operation cache after receiving acknowledge"),Ot()}nn?(T.error("EditApplications.sendActionsBuffer(): sent successfully, but internal error detected!"),t.reject()):0===Ct.length?t.resolve():Mt&&mt.isProcessingExternalOperations()?(ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: sendActionsBuffer: External operations are currently applied. Calling sendActions later in operations:after handler!"),ae.info("DEBUGGING ***********************************************"),mt.one("operations:after",_t),t.resolve()):Mt&&Zn>0?(ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: sendActionsBuffer: External operations are still missing. Calling sendActions later in operations:after handler!"),ae.info("DEBUGGING ***********************************************"),mt.one("operations:after",_t),t.resolve()):e()}).fail(function(e){T.error("EditApplications.sendActionsBuffer(): rtConnection.sendActions promise failed!"),t.reject(e)}),Ct=[]}var t=null;return function(){if(T.log("EditApplication.sendActions(): entered"),wt)return T.log("EditApplication.sendActions(): sending in progress - using current promise"),t.promise();if(nn)return T.error("EditApplication.sendActions(): internal error detected - promise rejected!"),$.Deferred().reject();if(Mt&&se(Ct,zn),0===Ct.length)return T.log("EditApplication.sendActions(): no need to send action buffer empty"),$.when();if(Mt){if(Zn>=0)return ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: sendActions: Not all external operations are currently applied. Coming back later, when all external ops are applied!"),ae.info("DEBUGGING ***********************************************"),St.once("docs:ackosn:updated",It),t.promise();if(mt.isProcessingExternalOperations())return ae.info("DEBUGGING ***********************************************"),ae.info("DEBUGGING: sendActions: External operations are currently applied. Coming back later in operations:after handler!"),ae.info("DEBUGGING ***********************************************"),mt.one("operations:after",_t),t.promise()}return t=St.newDeferred("EditApplication.sendActions").always(function(){T.log("EditApplication.sendActions(): current send promise resolved - sendingActions = false"),wt=!1,Ut=_.now(),f()}),wt=!0,f(),e(),t.promise()}}(),si=function(){var e=St.createDebouncedMethod("EditApplication.storeAndSendDebounced",function(e){var t=!1;T.withLogging(function(){var t=e.operations.length>0?JSON.stringify(_.last(e.operations)):null;T.log("EditApplication.storeAction(): "+(t?"last operation: "+t:"no operations provided"))}),Bt&&Un.length>0&&(Ct=Bt.call(St,Ct,Un),Bt=null,Un=[],t=!0),!nn&&(e.operations.length>0||t)&&(e.operations.length>0&&(Ct.push(e),Mt&&(zn.push(e),ae.info("DEBUGGING: Adding local action to local operation cache: "+JSON.stringify(zn)))),Kt=!0,bt=!0,f())},ai,{delay:Ht,maxDelay:Ht});return function(t){wn?e(t):(T.log("EditApplication.registerAction(): cached action during non-distribution mode"),Un.push(t))}}(),li=_.once(function(){if(C(!1),st()){var e=s&&s.prepareLeaveDataHandler,t=e?e.call(St):null;yt.emergencyLeave(t)}});this.leaveBusyDuringImport=_.once(function(e,t){return In=St.launchTracker.step("previewStart","EditApp: Busy state during import process left"),f(),Nt.showAfterImport(e,t)}),this.getLaunchOption=function(e){return o&&o[e]},this.createDebouncedActionsMethodFor=function(e,t,n,i,r){var o=!1;return e.createDebouncedMethod(t,n,function(){if(!o){if(!St.isImportFinished()||!mt.isProcessingActions())return i.call(e);var t=mt.waitForActionsProcessed();o=!0,e.waitForSuccess(t,function(){o=!1,i.call(e)})}},r)},this.checkStartOfExternalOperations=function(){!Mt||Tt||mt.isProcessingInternalOperations()||St.trigger("docs:operations:completed")},this.isRemovalOfInternalBlockerPossible=function(){return Mt&&!Tt},this.getFileFormat=function(){var e;return null===Dt&&(e=this.hasFileDescriptor()?this.getFullFileName():o&&o.templateFile?o.templateFile.filename:"",Dt=e?R.getFileFormat(e):null),Dt||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&R.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&R.isScriptable(this.getFullFileName())},this.isShutdownReceived=function(){return!1},this.getClientId=function(){return At},this.getShortClientId=function(){return At.slice(0,4)},this.getDocUID=function(){return st()?yt.getDocUID():null},this.getLoadMode=function(){return $n},this.getEditClientId=function(){return an},this.getEditClientUserName=function(){return _e(an)},this.getClientOperationName=function(){return vt},this.getPendingActions=function(){return Ct},this.resetPendingActions=function(){Ct=[]},this.getActiveClients=function(){return On},this.isLocallyModified=function(){return Kt},this.isPrepareLosingEditRights=function(){return sn},this.sendActionRequest=function(e,t,n){return st()?(n=_.extend({method:"POST"},n),this.sendFileRequest(K,{action:e,docuid:yt.getDocUID(),requestdata:JSON.stringify(t)},n)):St.createRejectedPromise()},this.sendQueryRequest=function(e,t,n){return this.sendActionRequest("query",_.extend({},t,{type:e}),n)},this.sendAddImageIdRequest=function(e){return st()?yt.addImageId(e):$.when()},this.sendLogMessage=v.LOG_ERROR_DATA?function(e){return St&&St.allowStoreLogFile()&&St.sendLogErrorData({errorCode:e}),this}:i.NOOP,this.isRenameEnabled=function(){return!te&&(!dn&&!v.getDebugFlag("office:simple-filestore")||!this.isDocumentEncrypted()&&!Mt)},this.rename=function(e){var t=this.getFileDescriptor(),n=i.getStringOption(t,"filename",this.getFullFileName()),r=i.getStringOption(t,"com.openexchange.file.sanitizedFilename",n),o=W(e);if(this.setUnsavedFileName(null),Qt)return Q.warn("EditDocument.rename(): multiple calls, ignoring subsequent call"),Qt;if(0===o.length)return $.Deferred().reject();if(o===this.getShortFileName())return $.when();o+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(o+=u.GUARD_EXT),this.updateFileDescriptor({filename:o}),Fn=this.createDeferred("EditApplication.renameAndReload",{background:!0});var a=s&&s.prepareRenameHandler;return Qt=a?j(a.bind(St)):H(),Qt=Qt.then(ai),Qt=Qt.then(function(){return st()?yt.renameDocument({target_filename:o}):q()}),(Qt=Qt.then(function(e){var t=new g(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?Fn.promise():t.isError()?q(t):e})).done(function(e){Jt=!0,St.updateFileDescriptor({filename:i.getStringOption(e,"fileName",n),"com.openexchange.file.sanitizedFilename":i.getStringOption(e,"com.openexchange.file.sanitizedFilename",r)})}),Qt.fail(function(e){if("abort"!==e){var t=g.isErrorCode(e)?e:new g(e);t.setErrorContext(p.RENAME);var i=I.getMessageData(t);i.restoreHidden=!1,Q.warn("EditApplication.rename() error: "+t.getErrorText()),Nt.yell(i)}St.updateFileDescriptor({filename:n})}),Qt.always(function(){Qt=null})},this.getCurrentFileName=function(){return Qt?Nt.getToolbarFileNameFieldValue():St.getShortFileName()},this.hasUnsavedChangesOffice=function(){return rt()||!!Qt||this.hasUnsavedFileName()||!!mt&&mt.hasUnsavedComments()},this.hasUnsavedChanges=function(){return(!ox.tabHandlingEnabled||n.getLoggingOutState()!==n.LOGGING_OUT_STATE.FOLLOWER)&&(!(!st()||!yt.isConnected())&&(this.hasUnsavedChangesOffice()||yt.hasPendingActions()))},this.setUserState=function(e){return this.isInternalError()||$t===e||($t=e,d()),this},this.getState=function(){return $t&&!this.isInternalError()?$t:Vt},this.isEditable=function(){return Yt},this.isOnline=function(){return"offline"!==Vt},this.isInternalError=function(){return"error"===Vt},this.setInternalError=function(e,t,n,r){var o,a=g.isErrorCode(e)?e:new g(e),s=null,l=null,c=null,u=!0,d=i.getObjectOption(r,"additionalData",{}),p=g.isErrorCode(n)?n:a,E=!1,h=i.getObjectOption(r,"silentShutdownConfig",{}),O=a.isError();if(_.isString(t)&&a.setErrorContext(t),s=St.getErrorState(),(o=!_.isObject(s)||!s.isError())?(St.setErrorState(a),E=!0):_.isObject(s)&&(a=s,l=qn),c=St.getErrorState(),g.isErrorCode(c)&&Q.error("Internal error: "+c.getErrorText()),O)nn=!0,Wt=!1,en=!0,C(!1),dt(h);else{var S=!_.has(vn,a.getCodeAsConstant()),m=yn!==a.getCodeAsConstant();u=S&&m,I.isOnceWarning(a.getCodeAsConstant())&&(vn[a.getCodeAsConstant()]=!0),yn=a.getCodeAsConstant()}f(a),_.isObject(l)&&!E||(l=I.getMessageData(a,_.extend({causeError:p,viewerMode:St.isViewerMode()},U(),d)),St.extendMessageData(l),xn="document/reload"===i.getStringOption(l.action,"itemKey"),qn=l),i.getBooleanOption(r,"showMessage",!0)&&u&&Nt&&Nt.yell&&Nt.yell(l),O&&o&&(St.sendLogErrorData({errorCode:l.errorCode}),St.allowStoreLogFile()&&St.createLogFileInDrive())},this.createLogFileInDrive=function(){var e=St.generateLogData();if(e){var t=new re(this.getWindowId(),F("A debug report is uploaded to Drive/myFiles/crashdata. This can take a while. Closing the browser tab cancels the upload. The report may contain content of previously opened documents."),{title:F("Generating debug report"),classes:"generate-log-dialog",okLabel:F("Close ")}),n=$('<div style = "padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result">').html('<div class="busy-indicator io-ox-busy"></div>');t.append(n),t.show(),St.sendLogErrorData({logData:e}).done(function(){n.html('<i class="fa fa-check" aria-hidden="true"></i><span>Finished upload</span>')}).fail(function(){n.html('<i class="fa fa-exclamation-circle" aria-hidden="true"></i><span>Could not upload file</span>')})}},this.allowStoreLogFile=function(){return v.LOG_ERROR_DATA&&!!St&&!St.isDocumentEncrypted()},this.sendLogErrorData=function(e){function t(e){return r?"hidden":e}var n=_.has(e,"errorCode"),i=_.has(e,"logData");if(!n&&!i)return St.createRejectedPromise();var r=!v.LOG_ERROR_DATA,o=St.getFileDescriptor(),a={action:"logclientdata",logAnonymous:String(r),fileId:String(t(o&&o.id)),folderId:String(t(o&&o.folder_id)),fileName:String(t(St.getFullFileName())),userId:String(ox&&ox.user_id),docUid:String(ei),errorCode:n?function(){var t=e&&e.errorCode,n=t||"unknownError";return String(n)}():"",logData:i&&St.allowStoreLogFile()?function(){var t=e&&e.logData;return String(t)}():""};return St.sendRequest("oxodocumentfilter",a,{method:"POST",dataType:"xml"})},this.setCurrentInfoState=function(e,t){var n=null,r=i.getBooleanOption(t,"showMessage",!0),o=null;i.getBooleanOption(t,"resetWarning",!1)&&(o=St.getErrorState(),_.isObject(o)&&o.isError()||St.setErrorState(new g)),St.setInfoState(e),r&&(n=S.getMessageData(e,_.extend({},U(),t)),St.extendMessageData(n),_.isObject(n)&&Nt.yell(n))},this.isLocked=function(){return nn||en},this.isAcquireEditRightsEnabled=function(){return!Mt&&st()&&!this.isLocked()&&this.isOnline()&&!Yt},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&_n.length<=1},this.acquireEditRights=function(){le.log("$back(Orchid)acquireEditRights - User wants to acquireEditRights -> Button pressed  ");{if(this.isAcquireEditRightsEnabled())return Pn.start();xe()}},this.saveDocumentAs=function(t,n,r,a){var s=n,l=null,c=St.getFileDescriptor(),d=null,f=!1;switch(r){case X.NATIVE:if(a&&a.encrypted){s+="."+St.getFileExtension()+u.GUARD_EXT,d=(d=u.authorizeGuard().then(function(e){return o.auth_code=e,St.flushDocument(oe.DOWNLOAD)},function(){return f=!0,q()})).then(function(){var e=c.file_options||{},n=e.params||{};return _.extend(n,{cryptoAction:"Encrypt",filedisplay:s,ignoreWarnings:!1}),c.file_options=_.extend(e,{params:n}),u.copyFile(c,t)});break}case X.TEMPLATE:s+="."+St.getFileExtension(),d=st()?yt.copyDocument({file_id:St.getFileParameters().id,target_filename:n,asTemplate:r===X.TEMPLATE,target_folder_id:t}):q();break;case X.PDF:s+=".pdf",d=(d=(d=St.flushDocument(oe.DOWNLOAD)).then(function(){return u.propagateChangeFile(c)})).then(function(){return u.getFileModelFromDescriptor(c).then(function(n){return e.sendConverterRequest(n,{documentformat:"pdf",saveas_filename:s,saveas_folder_id:t})})});break;default:return Q.error('EditApplication.saveDocumentAs - unknown file type "'+r+'"'),q()}return d=d.then(function(e){var t=new g(e);return t.isError()?q(t):e}),d=d.then(function(e){return s=i.getStringOption(e,"filename")||s,u.deleteFromCache(t),u.getPath(t).then(function(t){return l=u.preparePath(t),e})}),(d=d.then(function(e){if(r!==X.PDF){C(!1),r===X.TEMPLATE&&St.setCurrentInfoState(O.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:s,fullPathName:l,type:"success",duration:1e4});var n=i.getStringOption(e,"id",null);return!n&&a&&a.encrypted&&(n=_.isArray(e)?i.getStringOption(_.first(e),"data",null):e),t=t||i.getStringOption(e,"folder_id",null),u.getFile({id:n,folder_id:t}).done(function(e){e.title=u.getFileBaseName(e.filename),St.updateFileDescriptor(e),o.action="load",delete o.template,St.reloadDocument()})}St.setCurrentInfoState(O.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:s,fullPathName:l,type:"success",duration:1e4})})).fail(function(e){"cancel"===e||f||((e=g.isErrorCode(e)?e:new g(g.GENERAL_ERROR)).setErrorContext(p.SAVEAS),Q.warn('EditApplication.saveDocumentAs(): Error code "'+e.getCodeAsConstant()+'"'),Nt.yell(I.getMessageData(e,U())))}),d},this.isReloadEnabled=function(){return xn},this.reloadDocument=function(e){var t=this.getFileDescriptor(),n=this.getFullFileName(),i=R.getEditModule(n);return i?R.isNative(n)?(e=_.extend({},e,{action:"load",file:t}),o.auth_code&&(e.auth_code=o.auth_code),this.quit("reload").done(function(){window.setTimeout(function(){ox.launch(i+"/main",e)},500)})):(Q.error("EditApplication.reloadDocument(): unsupported document type"),this):(Q.error("EditApplication.reloadDocument(): unknown application type"),this)},this.restoreDocument=function(e,t){var n=i.getArrayOption(t,"actions",null),r=St.getFileDescriptor(),o=null;if(v.RESTORE_DOCUMENT_ENABLED){if(!Gn){if(Gn=!0,Hn=!1,_.isNull(n)){var a=y.handleMinifiedActions(St.getPendingActions());o=st()?function(e,t){var n=y.getActionsArray(e),i=y.getActionsArray(t);return _.isArray(n)&&_.isArray(i)?n.concat(i):n}(yt.getPendingActions(),a):a}else o=n;en=!0,C(!1),f(),nn=!0;var s={action:"saveaswithbackup",file_id:r.id,target_filename:r.filename,target_folder_id:r.folder_id,restore_id:Ln,operations:_.isNull(o)?o:JSON.stringify(o)};St.sendFileRequest(K,s,{method:"POST"}).then(function(t){var n=new g(t),r=St.newDeferred("EditApplication.restoreDocument"),o=i.getStringOption(t,E.RESTORED_FILEID,null),a=i.getStringOption(t,E.RESTORED_FILENAME,null),s=i.getStringOption(t,E.RESTORED_FOLDERID,null),l=null,c={};_.isObject(t)&&_.isString(a)&&_.isString(s)?u.getPath(s).always(function(e){l=u.preparePath(e),r.resolve(l)}):r.resolve(null),r.always(function(t){var i=_.isString(t);n.isError()||(n=new g({errorClass:g.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),c[E.RESTORED_FILENAME]=a,c[E.RESTORED_PATHNAME]=l,c[E.ORIGINAL_FILEID]=St.getFileDescriptor().id,i&&St.updateFileDescriptor({id:o,folder_id:s}),St.setInternalError(n,e.getErrorContext(),e,{additionalData:c})})},function(){St.setInternalError(e)})}}else St.setInternalError(e)},this.rejectEditAttempt=function(e){if(St.isViewerMode())return this;switch(e){case"image":Nt.yell({message:F("The image could not be inserted.")});break;case"siri":St.setInternalError(h.ERROR_SIRI_NOT_SUPPORTED,p.GENERAL);break;case"loadingInProgress":St.setCurrentInfoState(O.INFO_LOADING_IN_PROGRESS);break;default:St.isImportFinished()?M():St.setCurrentInfoState(O.INFO_LOADING_IN_PROGRESS)}return this},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return t.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),i=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name+" "+e.last_name):e.last_name?_.noI18n(e.last_name):e.first_name?_.noI18n(e.first_name):n;return{id:e.user_id,displayName:n,operationName:i,guest:t}})},this.updateUserData=function(){var e=null;return St.createDebouncedMethod("EditApplication.updateUserData",function(t){return e=t,this},function(){!st()||"resolved"!==St.getImportFinishPromise().state()||nn||St.isInQuit()||yt.updateUserData("updateuserdata",e)},{delay:500,maxDelay:1e3})}(),this.registerAuthorItem=function(e){if("authorId"in e&&"authorName"in e){var t=e.authorId,n=(_.isFinite(t)||_.isString(t))&&i.getStringOption(e,"authorName","").trim()||"";n&&(Cn[t]={id:t,name:n,initials:i.getStringOption(e,"initials","").trim()||null,providerId:i.getStringOption(e,"providerId","").trim()||null,userId:i.getStringOption(e,"userId","").trim()||null})}},this.getRegisteredAuthorItemById=function(e){return pt(e)},this.getAuthorColorIndex=function(e){return a.getSchemeColor(Et(e))},this.addAuthors=function(e){return Tn=_.union(Tn,e),this},this.stopOperationDistribution=function(e){return wn=!1,St.convertToPromise(e.call(St)).always(function(){wn=!0})},this.isOperationsBlockActive=function(){return bn},this.enterBlockOperationsMode=function(e){bn=!0,it()&&(St.trigger("docs:operations:remove",Tt.operations.length),Tt=nt()),e.call(St),bn=!1},this.isMultiSelectionApplication=function(){return qt},this.isSnapshotApp=function(){return jt},this.isFirstTabActivated=function(){return kn},this.getLoadDocInfo=function(){return Xn},this.isOTEnabled=function(){return Mt},this.getOTManager=function(){return Rt||(Rt=r.createOTManager(this.docModel))},this.transformPositionWithLocalActions=function(e,t){return this.getOTManager().transformPosition(e,zn,t)},this.getOTStatistics=function(){return{extOpCount:Qn,otCount:Rt?Rt.getTotalCount():0}},this.setOTBlockingOpsMode=function(e){Wn=e},this.isOTBlockingOpsMode=function(){return Wn},this.hasLocalActionsWithoutAck=function(){return Mt&&zn.length>0},this.getServerOSN=function(){return Yn},this.generateLogData=function(){var e=J();if(!e)return"";var t=navigator.userAgent,n=ei,i=ti,r=this.getFullFileName();return t+"\ndoc_uid: "+n+"\nclient_uid: "+i+"\napp: "+this.appType+"\nfileName: "+r+"\n \n"+e},this.debugTypeError=v.DEBUG?{testPlace:null,activateTestPlace:function(e){this.testPlace=e},test:function(e){this.testPlace===e&&(Q.info("You should see a typeError now at",e),this.debugxyz.debugTypeErrorXYZ())}}:$.noop,(Pn=new ce(this)).startHook.on(function(){St.trigger("docs:acquireeditrights:start")}),Pn.finishHook.on(function(){St.trigger("docs:acquireeditrights:end")}),Kn=new ie(function(){return st()?yt.syncStable().catch(_.noop):H()},{delay:3e4,interval:3e4,windowId:this.getWindowId(),contextMsg:"EditApplication.osnBeacon",background:!0}),this.onInit(function(){mt=this.docModel,Nt=this.docView,this.waitForImport(function(){Sn=St.launchTracker.step("triggerImportSuccess","EditApp: End of import process notified"),Mn=Sn,T.log("Load-mode:",$n)}),f(),ii(),Ie(),this.listenTo(mt,"operations:error",function(){C(!1)}),this.on("docs:operations:completed",Ye),R.supportsEditMode(St.appType)||(en=!0,C(!1),f(),M(R.DOM_TEXT_EDIT_ALERT,-1)),ln&&fn&&(Q.info("EditApplication.onInit(): saving document to local storage is active"),ee?Q.info("EditApplication.onInit(): current browser supports local storage"):Q.warn("EditApplication.onInit(): current browser does not support local storage")),this.on("docs:flush:success",function(){bt=!1}),c.BROWSER_TAB_SUPPORT&&(mt.listenTo(c.hideTabHook,function(){bt&&St.flushDocument(oe.USER)}),mt.listenTo(c.showTabHook,function(){_.browser.Safari&&Nt.grabFocus({restoreBrowserSelection:!0})}))},this),this.registerBeforeUnloadHandler(function(e){e||li()}),this.registerUnloadHandler(function(){li()}),this.registerBeforeQuitHandler(function(){if(v.DEBUG&&St.debugTypeError.test("sync-beforeQuitHandler"),nn)return H();var e=St.isOnline()&&St.hasUnsavedFileName()?St.rename(St.getUnsavedFileName()):H();return e=e.then(function(){return St.isOnline()?at(oe.QUIT):null}),e=e.then(function(){return We()&&St.hasUnsavedChangesOffice()?Nt.showQueryDialog(null,F("This document contains unsaved changes. Do you really want to close?")):void 0})}),this.registerQuitHandler(function(e){function t(){return $.when(jn).always(function(){T.log("EditApplication.quitHandler.finalizeRTConnection called"),lt()})}function n(){try{if(T.log("EditApplication.quitHandler.connectionGateKeeper entered"),!st())return;if(ut())return;var e=yt.getCloseLeaveState();switch(T.log("EditApplication.quitHandler.connectionGateKeeper - connectionOpenState:",e),e){case"unknown":return void dt();case"closing":case"closed":return void dt({skipCloseDoc:!0});case"disconnecting":case"disconnected":return;default:return void dt()}}catch(e){dt(),Q.warn("Error caught in EditApplication.quitHandler.connectionGateKeeper:",e)}}var i=null;try{T.log("EditApplication.quitHandler - reason",e),v.DEBUG&&St.debugTypeError.test("sync-quithandler"),"reload"===e?(dt(),i=$.when()):i=ft(e)}catch(e){i=$.when(),Q.warn("Error caught in EditApplication.quitHandler:",e)}return i=i.then(n,n),i=i.then(t,t)}),this.waitForImportStart(function(){m.logState("import","app/loading","pending")}),this.once("docs:state:preview",function(){m.logState("import","app/preview","pending")}),this.waitForImport(function(){m.logState("import","app/preview","resolved"),m.logState("import","app/loading","resolved")}),this.waitForImportSuccess(function(){Mt&&Kn.start()}),this.registerDestructor(function(){Kn.destroy(),Pn.destroy(),o=s=St=mt=Nt=null,yt=Ct=Tt=Un=null,Ft=Lt=null,Gt=xt=kt=null,Pt=Bt=null,Qt=pn=hn=On=null,_n=Kn=null,Pn=Bn=null})})});