define("io.ox/office/editframework/model/editmodel",["static/3rd.party/crypto-js/crypto-js.js","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/baseframework/model/basemodel","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operations","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/operationcontext","io.ox/office/editframework/model/operationgenerator","io.ox/office/editframework/model/modelattributesmixin","io.ox/office/editframework/model/undomanager"],function(e,t,n,o,r,i,s,a,l,c,u,p,d,f){"use strict";var g=n.isPromise,O=o.ValueMap,h=r.Logger,m=c.otLogger,y=c.isOperationRemoved,v=u.OperationContext,S=p.resolveOperations,x=p.OperationGenerator,M=new h("office:log-ops",{tag:"OP",tagColor:16711935});return i.extend({constructor:function(n,o){function r(e,n){var o=t.getBooleanOption(n,"async",!1);if(A.isProcessingActions())return H&&(j&&(U?(m.info("Collision: External operations are currently applied"),A.trigger("docs:ot:collision")):R&&m.info("Collision: Internal operations are currently applied")),m.info("DEBUGGING: New failing operations: ",n&&n.operations),m.info("DEBUGGING: Failing operations async state: "+!!o),m.info("DEBUGGING: Currently applied operations: ",L)),t.error("EditModel.enterProcessActionsMode(): recursive call"),!!o&&A.createRejectedPromise({cause:"recursive"});G=A.newDeferred("EditModel.enterProcessActionsMode").always(function(){var e=G?G.state().replace(/ed$/,"ing"):"destructed";M.log("EditModel.enterProcessActionsMode(): "+e+" promise...")}),L=n&&n.operations||null;var r=e.call(A);return g(r)?(r.progress(G.notify.bind(G)),r.done(G.resolve.bind(G)),r.fail(G.reject.bind(G)),r):(!0===r?G.resolve():G.reject(),o?G.promise():r)}function c(e,o){return j?(H&&(U&&!o?m.info("Collision: Receiving internal operation during applying external operations"):R&&o?m.info("Collision: Receiving external operation during applying internal operations"):m.info("Collision: State of external: "+o+", processingExternalOperations: "+U+", processingInternalOperations: "+R)),t.error("EditModel.beginProcessOperations(): recursive call - currently processing operations."),!1):n.isInternalError()?(t.error("EditModel.beginProcessOperations(): illegal call - application is in error state."),!1):(A.trigger("operations:before",e,o),j=!0,H&&(o?U=!0:R=!0),!0)}function u(e,t,n){j=!1,H&&(U=!1),A.trigger("operations:after",t,n),A.trigger(e?"operations:success":"operations:error",t,n)}function p(e){var t=e.getStr("name"),n=F.get(t,null);return e.ensure(n,"unknown operation %s",t),n}function h(e){return e||n.isEditable()}function E(e,o,r,i){function a(){var e="EditModel.applyOperation(): "+_.printf.apply(_,arguments);return t.error(e),n.sendLogMessage(e),!1}if(M.log("i="+D+", op=",e),!_.isObject(e))return a("Expecting operation object.");try{var l=new P(A,e,o,i),c=p(l);if(o&&l.has("osn")){var u=l.getInt("osn");if(l.ensure(u>=0,"invalid OSN: %d",u),-1===B&&A.setOperationStateNumber(u),!H&&B!==u)return a("Wrong operation state number. current=%d operation=%d",B,e.osn)}o||(e.osn=H?n.getServerOSN():B,e.opl=1,s.DEBUG&&(e.dbg_user_id=ox.user_id)),B>=0&&A.setOperationStateNumber(B+l.getOptInt("opl",1)),I&&I.call(A,e);var d=l.getOptStr("scope");if(!(r||"filter"===d||H&&y(e))&&(c.call(A,l),T=e,H&&!i)){var f=o?"operation:external":"operation:internal";A.trigger(f,e)}}catch(t){return a('Operation failed. name="%s" msg="%s" osn=%d source=%s op=%s',e.name,t.message,D+1,o?"ext":"int",JSON.stringify(e))}return D+=1,!0}function b(e,t,n){var o=n&&n.sendOnly,r=!A.isImportFinished(),i=!1;return e=S(e,n),!h(t)||0===e.length||(!t&&N&&(e=N.call(A,e)),c(e,t)&&C.enterUndoGroup(function(){i=e.every(function(e){return E(e,t,o,r)})}),u(i,e,t),i)}function w(e,n,o){var r=o&&o.sendOnly,i=!A.isImportFinished(),s=null,a=D;return 0===(e=S(e,o)).length?A.createResolvedPromise(null):(s=c(e,n)?C.enterUndoGroup(function(){return A.iterateArraySliced(e,function(o,s){return h(n)?E(o,n,r,i)?void 0:A.createRejectedPromise({cause:"operation"}):(e=e.slice(0,s),t.BREAK)},"EditModel.applyOperationsAsync")}):A.createRejectedPromise({cause:"recursive"}),A.waitForSuccess(s,function(){u(!0,e,n,o)}),A.waitForFailure(s,function(t){"abort"===t?u(!0,e.slice(0,D-a),n,o):u(!1,e,n,o)}),s)}var k=t.getFunctionOption(o,"generatorClass",x),P=t.getFunctionOption(o,"contextClass",v),A=this,C=null,N=t.getFunctionOption(o,"operationsFinalizer",null),I=t.getFunctionOption(o,"storageOperationCollector",null),G=null,F=new O,j=!1,R=!1,U=!1,D=0,B=-1,T=null,H=n.isOTEnabled(),J=t.getBooleanOption(o,"slideMode",!1),z=J&&(t.IOS||t.CHROME_ON_ANDROID),L=null;i.call(this,n),this.registerContextOperationHandler=function(e,t){return F.insert(e,t),this},this.registerOperationHandler=function(e,t){return this.registerContextOperationHandler(e,function(e){var n=t.call(this,e.operation,e.external);e.ensure(!1!==n,"operation handler failed")})},this.serializeToJSON=function(){return t.warn("EditModel.serializeToJSON(): not implemented"),{}},this.getSelectionState=function(){},this.setSelectionState=function(){t.error("EditModel.setSelectionState: missing implementation")},this.isProcessingActions=function(){return!!G&&"pending"===G.state()},this.waitForActionsProcessed=function(){return G?G.catch(_.noop):this.createResolvedPromise()},this.isProcessingOperations=function(){return j},this.isProcessingExternalOperations=function(){return U},this.isProcessingInternalOperations=function(){return R},this.setInternalOperationBlocker=function(e){n.isOTEnabled()&&(e?R=e:(!R||R&&n.isRemovalOfInternalBlockerPossible())&&(R=e,n.checkStartOfExternalOperations()))},this.sendOperations=M.profileMethod("EditModel.sendOperations()",function(e,t){return b(e,!1,_.extend({},t,{sendOnly:!0}))}),this.applyOperationsAsync=M.profileMethod("EditModel.applyOperationsAsync()",function(e,t){return r(function(){return w(e,!1,t)},{async:!0,operations:e})}),this.applyOperations=M.profileMethod("EditModel.applyOperations()",function(e,t){return r(function(){return b(e,!1,t)},{operations:e})}),this.applyExternalOperations=M.profileMethod("EditModel.applyExternalOperations()",function(e,t){return 0===e.length?$.when():(t&&t.expand&&l.handleMinifiedActions([{operations:e}],!0),r(function(){return w(e,!0)},{async:!0,operations:e}))}),this.invokeOperationHandler=function(e){var t=new P(this,e,!1),n=p(t);return C.disableUndoSync(n.bind(this,t)),this},this.createOperationGenerator=function(e){return new k(this,e)},this.createAndApplyOperations=M.profileMethod("EditModel.createAndApplyOperations()",function(e,n){var o=new(t.getFunctionOption(n,"generatorClass",k))(this,n),i=t.getBooleanOption(n,"storeSelection",!1)?_.noop:t.getFunctionOption(n,"storeSelection",null),s=o.isImmediateApplyMode();return r(function(){var r=i?n&&n.undoSelectionState||A.getSelectionState():null,a=null;try{a=A.convertToPromise(e.call(A,o))}catch(e){a=A.createRejectedPromise(e)}return a=a.then(function(e){return s?A.sendOperations(o)?e:$.Deferred().reject({cause:"operation"}):w(o,!1).then(_.constant(e))}),a=a.then(function(e){var s=null;switch(i&&(i.call(A),s=n&&n.redoSelectionState||A.getSelectionState()),t.getStringOption(n,"undoMode","generate")){case"generate":C.enterUndoGroup(function(){C.addUndo(o.getOperations({undo:!0}),o.getOperations(),r,s)},A,t.getObjectOption(n,"undoOptions",null));break;case"clear":C.clearUndoActions();break;case"skip":break;default:t.error("EditModel.createAndApplyOperations(): unknown undo mode")}return e})},{async:!0})}),this.getOperationsCount=function(){return D},this.getOperationStateNumber=function(){return B},this.setOperationStateNumber=function(e){return B!==e&&(B=e,H||this.trigger("change:osn",e)),this},this.getLastOperation=function(){return T},this.getUndoManager=function(){return C},this.useSlideMode=function(){return J},this.getSlideTouchMode=function(){return z},this.getDocumentChecksum=function(){var t=this.serializeToJSON(),n=e.MD5(JSON.stringify(t)).toString();return A.trigger("update:checksum",n),n},this.hasUnsavedComments=function(){return!1},this.discardUnsavedComments=function(){},C=new f(this,o),d.call(this,o),this.registerContextOperationHandler(a.NOOP,_.noop),this.registerDestructor(function(){C.destroy(),F.clear(),A=o=G=null,N=F=null,C=k=P=null})}})});