define("io.ox/office/spreadsheet/controller/tablemixin",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/view/dialogs","gettext!io.ox/office/spreadsheet/main"],function(e,t,n,r){"use strict";var a=t.SortDirection;return function(l){function o(n,r){var a=l.ensureUnlockedSheet();return a=a.then(function(){return p.createAndApplyOperations(function(a){if(n&&!n.isAutoFilter())return e.error("TableMixin.toggleTableFilter(): missing implementation"),b.createRejectedPromise();var o=b.createResolvedPromise();return n&&(o=o.then(function(){return n.generateDeleteOperations(a)})),r&&(o=o.then(function(){var e=l.getSelectedRanges();if(1!==e.length)return t.makeRejected("autofilter:multiselect");var n=p.getContentRangeForCell(e.first()),r=S.getUsedRange();return!(n=r?n.intersect(r):null)||S.areRangesBlank(n)?t.makeRejected("autofilter:blank"):O.generateInsertTableOperations(a,"",n,{table:{headerRow:!0}})})),o.catch(function(e){throw e.cause=e.cause.replace(/^table:/,"autofilter:"),e})},{storeSelection:!0})}),l.yellOnFailure(a)}function i(e){var t=l.ensureUnlockedSheet();return t=t.then(function(){return p.createAndApplyOperations(function(t){return e.generateRefreshOperations(t,{updateFilter:!0,updateSort:!0})},{storeSelection:!0})}),l.yellOnFailure(t)}function u(e,n){var r=n===a.VERTICAL;if((r?e.cols():v.countVisibleIndexes(e.colInterval()))>(r?t.MAX_SORT_LINE_LENGTH:t.MAX_SORT_LINES_COUNT))return!1;var l=n===a.HORIZONTAL;return!((l?e.rows():R.countVisibleIndexes(e.rowInterval()))>(l?t.MAX_SORT_LINE_LENGTH:t.MAX_SORT_LINES_COUNT))}function s(e){return l.ensureUnlockedRanges(e,{lockMatrixes:"full"}).then(function(){return u(e)?A.coversAnyMergedRange(e)?t.makeRejected("sort:merge:overlap"):e:t.makeRejected("sort:overflow")})}function c(e){var n=e?e.getDataRange():l.getActiveRange();if(!n)return t.makeRejected("sort:blank");if(!e&&S.areRangesBlank(n))return t.makeRejected("sort:blank");var a=s(n);return(a=a.then(function(){if(e||!n.singleCol()&&!n.singleRow())return n;var t=S.findContentRange(n);return t.equals(n)?n:(n.single()?b.createResolvedPromise(!0):l.showQueryDialog(r("Sorting"),r("Expand the selection?"),{cancel:!0})).then(function(e){return e?s(t):n})})).then(function(t){return l.selectRange(t,{active:l.getActiveCell()}),{sortRange:t,hasHeader:e?e.hasHeaderRow():S.hasHeaderRow(t)}})}function g(e,n,r,l,o){var i=u(e,r)?b.createResolvedPromise():t.makeRejected("sort:overflow");return i=i.then(function(){return p.createAndApplyOperations(function(t){return n?n.generateSortOperations(t,l):(o&&(e=e.clone()).start.move(1,r===a.HORIZONTAL),S.generateSortOperations(t,e,r,l))},{storeSelection:!0})})}function f(e,t){var n="toggle"===t?m:"descending"===t,r={index:l.getActiveCell()[0],descending:n},o=c(e);return o=o.then(function(t){return g(t.sortRange,e,a.VERTICAL,[r],t.hasHeader)}),o=o.then(function(){m=!n}),l.yellOnFailure(o)}function d(e){var t=c(e);return t=t.then(function(t){var r=t.sortRange;return new n.CustomSortDialog(l,r,e,t.hasHeader).show().then(function(t){return g(r,e,t.sortDir,t.sortRules,t.hasHeader)})}),t=t.then(function(){m=!1}),l.yellOnFailure(t)}function h(n,r,a){var o=l.ensureUnlockedSheet();return o=o.then(function(){var l=O.getTable(n);if(!l)return $.Deferred().reject();var o=l.getDataRange(),i=e.getObjectOption(a,"sort",null),u=!1;if(i){var s=l.getColumnModel(r).getMergedAttributeSet(!0).sort;u=_.some(i,function(e,t){return s[t]!==e})}return u&&o&&A.coversAnyMergedRange(o)?t.makeRejected("sort:merge:overlap"):p.createAndApplyOperations(function(e){var t=u&&"none"!==i.type;return l.generateChangeColumnOperations(e,r,a,{resetSort:t})},{storeSelection:!0})}),l.yellOnFailure(o)}var b=this,p=null,v=null,R=null,S=null,A=null,O=null,m=!1;this.registerItemsOnSuccess({"sheet/table/selected":{parent:"sheet/operation/unlocked/cell",get:function(){return O.findTable(l.getActiveCell())}},"sheet/table/selected/real":{parent:"sheet/table/selected",get:function(e){return e&&!e.isAutoFilter()?e:null}},"sheet/table/active":{parent:"sheet/table/selected",get:function(e){return e||O.getAutoFilter()}},"table/flags":{parent:"sheet/table/selected/real",get:function(e){return e?e.getStyleFlags():null}},"table/filter":{parent:"sheet/table/active",enable:function(e){return!e||e.isAutoFilter()},get:function(e){return!!e&&e.isAutoFilter()},set:function(e){return o(this.getParentValue(),e)}},"table/refresh":{parent:"sheet/table/active",enable:function(e){return!!e&&e.isRefreshable()},set:function(){return i(this.getParentValue())}},"table/sort/enabled":{parent:"sheet/table/selected",enable:function(e){var t=l.getSelectedRanges();if(1!==t.length)return!1;var n=t[0];return e?e.getRange().contains(n):!O.overlapsTables(n)}},"table/sort":{parent:"table/sort/enabled",get:function(){return m?"descending":"ascending"},set:function(e){return f(this.getParentValue(),e)}},"table/sort/dialog":{parent:"table/sort/enabled",set:function(){return d(this.getParentValue())},preserveFocus:!0},"table/stylesheet":{parent:"sheet/table/selected/real",enable:function(e){return!!e},get:function(e){return e&&e.getStyleId()||""},set:function(e){var t=l.ensureUnlockedSheet();return t=t.then(function(){return p.createAndApplyOperations(function(t){var n=l.getSelectedRanges(),r=O.createModelIterator();return e=e||null,b.iterateSliced(r,function(r){!r.isAutoFilter()&&r.getStyleId()!==e&&n.overlaps(r.getRange())&&r.generateChangeOperations(t,{styleId:e})},"TableMixin.changeTableStyle")},{storeSelection:!0})}),l.yellOnFailure(t)}},"table/column/attributes":{parent:"sheet/operation/unlocked/cell",set:function(e){return h(e.tableName,e.tableCol,e.attributes)}}}),this.listenTo(l,"change:activesheet",function(){p=l.getSheetModel(),v=p.colCollection,R=p.rowCollection,S=p.cellCollection,A=p.mergeCollection,O=p.tableCollection}),this.registerDestructor(function(){b=l=p=v=R=null,S=A=O=null})}});