define("io.ox/office/spreadsheet/model/addressfactory",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/spreadsheet/utils/interval","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/intervalarray","io.ox/office/spreadsheet/utils/addressarray","io.ox/office/spreadsheet/utils/rangearray","io.ox/office/spreadsheet/utils/cellanchor"],function(t,e,r,n,o,a,i,s,p,u,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var g=Math.min,f=Math.max,d=function(){function t(t,e){this.updateSheetSize(t,e)}return Object.defineProperty(t.prototype,"colCount",{get:function(){return this._maxCol+1},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"rowCount",{get:function(){return this._maxRow+1},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"maxCol",{get:function(){return this._maxCol},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"maxRow",{get:function(){return this._maxRow},enumerable:!0,configurable:!0}),t.prototype.getMaxIndex=function(t){return t?this._maxCol:this._maxRow},t.prototype.getSize=function(t){return(t?this._maxCol:this._maxRow)+1},t.prototype.updateSheetSize=function(t,e){this._maxCol=t-1,this._maxRow=e-1},t.prototype.parseInterval=function(t,e){var r=a.Interval.parseAs(t,e);return r&&r.last<=this.getMaxIndex(e)?r:null},t.prototype.parseIntervalList=function(t,e){var r=this,o=p.IntervalArray.map(n.splitTokens(t),function(t){return r.parseInterval(t,e)});return o.empty()?null:o},t.prototype.isValidInterval=function(t,e){return t.first>=0&&t.first<=t.last&&t.last<=this.getMaxIndex(e)},t.prototype.getEndInterval=function(t,e){return new a.Interval(t,this.getMaxIndex(e))},t.prototype.getFullInterval=function(t){return new a.Interval(0,this.getMaxIndex(t))},t.prototype.parseAddress=function(t){var e=i.Address.parse(t);return e&&e[0]<=this._maxCol&&e[1]<=this._maxRow?e:null},t.prototype.parseAddressList=function(t){var e=this,r=u.AddressArray.map(n.splitTokens(t),function(t){return e.parseAddress(t)});return r.empty()?null:r},t.prototype.isValidAddress=function(t){return t[0]>=0&&t[0]<=this._maxCol&&t[1]>=0&&t[1]<=this._maxRow},t.prototype.getClampedAddress=function(t){return new i.Address(n.clamp(t[0],0,this._maxCol),n.clamp(t[1],0,this._maxRow))},t.prototype.parseRange=function(t){var e=s.Range.parse(t);return e&&e.end[0]<=this._maxCol&&e.end[1]<=this._maxRow?e:null},t.prototype.parseRangeList=function(t){var e=this,r=l.RangeArray.map(n.splitTokens(t),function(t){return e.parseRange(t)});return r.empty()?null:r},t.prototype.isValidRange=function(t){return t.start[0]>=0&&t.start[0]<=t.end[0]&&t.end[0]<=this._maxCol&&t.start[1]>=0&&t.start[1]<=t.end[1]&&t.end[1]<=this._maxRow},t.prototype.isSheetRange=function(t){return this.isColRange(t)&&this.isRowRange(t)},t.prototype.getSheetRange=function(){return s.Range.create(0,0,this._maxCol,this._maxRow)},t.prototype.isColRange=function(t){return 0===t.start[1]&&t.end[1]===this._maxRow},t.prototype.getColRange=function(t){return r.isNumber(t)?s.Range.create(t,0,t,this._maxRow):s.Range.create(t.first,0,t.last,this._maxRow)},t.prototype.getColRangeList=function(t){var e=this;return l.RangeArray.map(t,function(t){return e.getColRange(t)})},t.prototype.isRowRange=function(t){return 0===t.start[0]&&t.end[0]===this._maxCol},t.prototype.getRowRange=function(t){return r.isNumber(t)?s.Range.create(0,t,this._maxCol,t):s.Range.create(0,t.first,this._maxCol,t.last)},t.prototype.getRowRangeList=function(t){var e=this;return l.RangeArray.map(t,function(t){return e.getRowRange(t)})},t.prototype.isFullRange=function(t,e){return e?this.isColRange(t):this.isRowRange(t)},t.prototype.getFullRange=function(t,e){return e?this.getColRange(t):this.getRowRange(t)},t.prototype.getFullRangeList=function(t,e){return e?this.getColRangeList(t):this.getRowRangeList(t)},t.prototype.getRangeGroups=function(t){var e=this;return o.arrayGroup(l.RangeArray,t,function(t){return e.isColRange(t)?"colRanges":e.isRowRange(t)?"rowRanges":"cellRanges"})},t.prototype.getBoundedMovedRange=function(t,e,r){return e=n.clamp(e,-t.start[0],this._maxCol-t.end[0]),r=n.clamp(r,-t.start[1],this._maxRow-t.end[1]),s.Range.create(t.start[0]+e,t.start[1]+r,t.end[0]+e,t.end[1]+r)},t.prototype.getCroppedMovedRange=function(t,e,r){var n=f(0,t.start[0]+e),o=f(0,t.start[1]+r),a=g(this._maxCol,t.end[0]+e),i=g(this._maxRow,t.end[1]+r);return n<=a&&o<=i?s.Range.create(n,o,a,i):null},t.prototype.parseCellAnchor=function(t){var e=c.CellAnchor.parseOpStr(t),r=e.point1,n=e.point2,o=r.a=this.getClampedAddress(r.a),a=n.a=this.getClampedAddress(n.a);return a[0]=f(o[0],a[0]),a[1]=f(o[1],a[1]),o[0]===a[0]&&(n.x=f(r.x,n.x)),o[1]===a[1]&&(n.y=f(r.y,n.y)),e},t}();e.AddressFactory=d});