define("io.ox/office/spreadsheet/model/formula/parser/expressionparser",["io.ox/office/tk/utils","io.ox/office/tk/containers","io.ox/office/tk/utils/class","io.ox/office/tk/locale/parser","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens"],function(e,t,r,n,a,s){"use strict";function c(e,t){this.token=e,this.index=-1,this.text=t,this.start=0,this.end=0}var o=t.arrayForEachReverse,i=a.Matrix,R=a.SheetRef,h=a.formulaLogger,l=a.RefSyntaxType;c.prototype.toString=function(){return this.token.toString()};var f=r.extendable(function(e,t){this.docModel=e,this.grammar=t,this.RE=t.RE,this.refGrammar=t.refGrammar});f.prototype._initOptions=function(t,r){this.refAddress=t,this.refSheet=e.getIntegerOption(r,"refSheet",-1),this.refSheetModel=this.docModel.getSheetModel(this.refSheet),this.wrapReferences=e.getBooleanOption(r,"wrapReferences",!1),this.autoCorrect=e.getBooleanOption(r,"autoCorrect",!1),this.extendSheet=e.getBooleanOption(r,"extendSheet",!1),this.unqualifiedTables=e.getBooleanOption(r,"unqualifiedTables",!1)},f.prototype._parseNextToken=function(e){var t=this.RE,r=null,a=null;return(r=t.STRING_LIT.exec(e))?this.createLiteralToken(r[0].slice(1,r[0].length-1).replace(/""/g,'"'),r[0]):(r=t.BOOLEAN_LIT.exec(e))?this.createLiteralToken(this.grammar.getBooleanValue(r[0]),r[0]):(r=t.ERROR_LIT.exec(e))?this.createLiteralToken(this.grammar.getErrorCode(r[0]),r[0]):(r=t.FRACTION_LIT.exec(e))?this.createLiteralToken(parseInt(r[1],10)+parseInt(r[2],10)/parseInt(r[3],10),r[0]):(r=t.WHITESPACE.exec(e))?this.createFixedToken("ws",r[0]):(r=t.SEPARATOR.exec(e))?this.createToken(new s.SeparatorToken,r[0]):(r=t.OPERATOR.exec(e))?this.createToken(new s.OperatorToken(this.grammar.getOperatorKey(r[0])),r[0]):(r=t.OPEN.exec(e))?this.createToken(new s.ParenthesisToken(!0),r[0]):(r=t.CLOSE.exec(e))?this.createToken(new s.ParenthesisToken(!1),r[0]):(r=t.MATRIX_OPEN.exec(e))?this._parseMatrixLit(e):(a=this.parseNextRefToken(e))?a:(r=n.parseLeadingNumber(e,{dec:this.grammar.DEC}))?this.createLiteralToken(r.number,r.text):(a=this.parseNextNameToken(e))?a:void 0},f.prototype._parseMatrixLit=function(e){function t(){return R.every(function(e,t){return 0===t||e.length===R[t-1].length})}for(var r=e,a="start",c=this.RE,o=null,R=[],h=null;"end"!==a;){switch(a){case"start":(o=c.MATRIX_OPEN.exec(e))&&(R.push(h=[]),a="open");break;case"open":case"sep":(o=c.WHITESPACE.exec(e))||((o=c.FRACTION_LIT.exec(e))?(h.push(parseInt(o[1],10)+parseInt(o[2],10)/parseInt(o[3],10)),a="lit"):(o=n.parseLeadingNumber(e,{dec:this.grammar.DEC,sign:!0}))?(h.push(o.number),o=[o.text],a="lit"):(o=c.STRING_LIT.exec(e))?(h.push(o[0].slice(1,o[0].length-1).replace(/""/g,'"')),a="lit"):(o=c.BOOLEAN_LIT.exec(e))?(h.push(this.grammar.getBooleanValue(o[0])),a="lit"):(o=c.ERROR_LIT.exec(e))&&(h.push(this.grammar.getErrorCode(o[0])),a="lit"));break;case"lit":0===e.length?(o=this.autoCorrect&&t()?[""]:null,a="end"):(o=c.WHITESPACE.exec(e))||((o=c.MATRIX_ROW_SEPARATOR.exec(e))?(R.push(h=[]),a="sep"):(o=c.MATRIX_COL_SEPARATOR.exec(e))?a="sep":(o=c.MATRIX_CLOSE.exec(e))&&(t()||(o=null),a="end"))}if(!o)return null;e=e.substr(o[0].length)}var l=r.substr(0,r.length-e.length);return this.createToken(new s.MatrixToken(new i(R)),l)},f.prototype.createToken=function(e,t){return new c(e,t)},f.prototype.createFixedToken=function(e,t){return this.createToken(new s.FixedToken(e,t),t)},f.prototype.createLiteralToken=function(e,t){return this.createToken(new s.LiteralToken(e),t)},f.prototype.createReferenceToken=function(e,t,r){return!e&&this.extendSheet&&this.refSheetModel&&(e={r1:new R(this.refSheet,!0),r2:null}),this.createToken(new s.ReferenceToken(this.docModel,t?t.r1:null,t?t.r2:null,e?e.r1:null,e?e.r2:null),r)},f.prototype.createNameToken=function(t,r,n,a){!t&&this.extendSheet&&this.refSheetModel&&this.refSheetModel.nameCollection.hasName(r)&&(t=new R(this.refSheet,!0));var c=!t&&/^\[0\]!/.test(n),o=new s.DefNameToken(this.docModel,r,t,c?0:null);return(e.getBooleanOption(a,"resolveTable",!1)?o.resolveTableModel():null)&&(o=new s.TableToken(this.docModel,r)),this.createToken(o,n)},f.prototype.createFunctionToken=function(e,t,r){var n=e?null:this.grammar.getFunctionKey(t);return this.createToken(n?new s.FunctionToken(n):new s.MacroToken(this.docModel,t,e),r)},f.prototype.createSheetRef=function(e,t){return this.refGrammar.createSheetRef(this.docModel,e,t)},f.prototype.createSheetRefs=function(e,t,r){return this.refGrammar.createSheetRefs(this.docModel,e,t,r)},f.prototype.createCellRangeRefs=function(e,t,r){return this.refGrammar.createCellRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},f.prototype.createColRangeRefs=function(e,t,r){return this.refGrammar.createColRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},f.prototype.createRowRangeRefs=function(e,t,r){return this.refGrammar.createRowRangeRefs(this.docModel,this.refAddress,this.wrapReferences,e,t,r)},f.prototype.parseNextRefToken=function(){return e.error("ExpressionParserBase.parseNextRefToken(): missing implementation"),null},f.prototype.parseNextNameToken=function(){return e.error("ExpressionParserBase.parseNextNameToken(): missing implementation"),null},f.prototype.parseFormula=function(e,t,r){this._initOptions(t,r);for(var n=[];e.length>0;){var a=this._parseNextToken(e)||this.createFixedToken("bad",e);n.push(a),e=e.substr(a.text.length)}h.logTokens("tokenize",n);var c=this.grammar.ISECT_SPACE;return o(n,function(e,t){var r=e.token,a=n[t-1],o=n[t+1];if("op"===r.type&&"sub"===r.value&&o&&"lit"===o.token.type){var i=o.token.value;if("number"==typeof i&&i>0){var R=a&&"ws"===a.token.type?n[t-2]:a;R&&!R.token.isType("op","sep","open")||(e.token=new s.LiteralToken(-i),e.text+=o.text,n.splice(t+1,1))}}if(c&&"ws"===r.type){var h=h=e.text.indexOf(" ");if(h>=0&&a&&a.token.isType("ref","name","close")&&o&&o.token.isType("ref","name","open","func")){if(h+1<e.text.length){var l=e.text.slice(h+1);n.splice(t+1,0,this.createFixedToken("ws",l))}n.splice(t+1,0,this.createToken(new s.OperatorToken("isect")," ")),h>0?(r.setValue(e.text.slice(0,h)),e.text=r.value):n.splice(t,1)}}},this),h.logTokens("postprocess",n),n.forEach(function(e,t){e.index=t,e.start=0===t?0:n[t-1].end,e.end=e.start+e.text.length}),n},f.prototype.destroy=function(){this.docModel=this.grammar=this.RE=this.refSheetModel=null};var E=f.extend(function(e,t){f.call(this,e,t)});E.prototype._parseTableRef=function(e,t){function r(){x[f.getTableRegionKey(T[1])]=!0,u="ref"}function n(e,t){"col1Name"in p?(T=null,u="end"):(p.col1Name=f.decodeTableColumn(e),p.col2Name=t?f.decodeTableColumn(t):null,u="ref")}function a(){n(T[1],T[2])}function c(e){e&&T[1]&&(p.openWs=!0),n(T[2]||T[3],T[4]||T[5])}function o(){T[1]&&(p.closeWs=!0),E||0!==T[2].length||(T=null),u="end"}var i=this.RE,R=e;t&&(e=e.substr(t.text.length));var h=i.TABLE_OPEN.test(e),l=t?t.token.resolveTableModel():null;if(t&&h&&!l)return null;if(t&&!h&&l)return this.createToken(new s.TableToken(this.docModel,t.token.value),t.text);if(!h)return t;if(!t&&this.grammar.UI&&this.unqualifiedTables&&this.refSheetModel&&(l=this.refSheetModel.tableCollection.findTable(this.refAddress)),!l)return null;for(var f=this.grammar,E=this.autoCorrect,u="start",T=null,p={},x={};"end"!==u;){switch(u){case"start":(T=i.TABLE_OPEN.exec(e))&&(T[1]&&(p.openWs=!0),u="open");break;case"open":(T=i.TABLE_CLOSE.exec(e))?o():(T=i.TABLE_SINGLE_REGION_NAME.exec(e))?r():(T=i.TABLE_SINGLE_COLUMN_NAME.exec(e))?a():(T=i.TABLE_REGION_REF.exec(e))?r():!this.grammar.UI&&(T=i.TABLE_COLUMN_RANGE_REF.exec(e))?a():!this.grammar.UI&&(T=i.TABLE_COLUMN_REF.exec(e))?a():this.grammar.UI&&(T=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?c(!0):this.grammar.UI&&(T=i.TABLE_MIXED_COLUMN_REF.exec(e))?c(!0):this.grammar.UI&&(T=i.TABLE_THISROW_REF.exec(e))&&(x.ROW=!0,u="row");break;case"ref":(T=i.TABLE_CLOSE.exec(e))?o():(T=i.TABLE_SEPARATOR.exec(e))&&(T[2]&&(p.sepWs=!0),u="sep");break;case"sep":(T=i.TABLE_REGION_REF.exec(e))?r():!this.grammar.UI&&(T=i.TABLE_COLUMN_RANGE_REF.exec(e))?a():!this.grammar.UI&&(T=i.TABLE_COLUMN_REF.exec(e))?a():this.grammar.UI&&(T=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?c():this.grammar.UI&&(T=i.TABLE_MIXED_COLUMN_REF.exec(e))&&c();break;case"row":(T=i.TABLE_CLOSE.exec(e))?(o(),p.closeWs&&(T=null)):(T=i.WHITESPACE.exec(e))||((T=i.TABLE_MIXED_COLUMN_RANGE_REF.exec(e))?c():(T=i.TABLE_MIXED_COLUMN_REF.exec(e))&&c())}if(!T)return null;e=e.substr(T[0].length)}switch((x=_.keys(x)).length){case 0:break;case 1:p.regionSpec=x[0];break;case 2:if("HEADERS,DATA"===(x=x.join(","))||"DATA,HEADERS"===x)p.regionSpec="HEADERS,DATA";else{if("DATA,TOTALS"!==x&&"TOTALS,DATA"!==x)return null;p.regionSpec="DATA,TOTALS"}break;default:return null}var k=R.substr(0,R.length-e.length);return this.createToken(new s.TableToken(this.docModel,l.getName(),p),k)},E.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,n=null;return(r=t.RANGE_REF.exec(e))&&(n=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(null,n,r[0]):(r=t.RANGE_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,4,8))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.RANGE_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.CELL_REF.exec(e))&&(n=this.createCellRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.CELL_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.CELL_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.COLS_REF.exec(e))&&(n=this.createColRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.COLS_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,4,6))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COLS_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.COL_REF.exec(e))&&(n=this.createColRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.COL_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COL_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ROWS_REF.exec(e))&&(n=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.ROWS_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,4,6))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROWS_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ROW_REF.exec(e))&&(n=this.createRowRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.ROW_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,4))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROW_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1,!0),n,r[0]):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),null,r[0]):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1,!0),null,r[0]):void 0},E.prototype.parseNextNameToken=function(e){var t=this.RE,r=this.refGrammar.RE,n=null;return(n=r.FUNCTION_REF.exec(e))?this.createFunctionToken(null,n[1],n[0]):(n=r.FUNCTION_3D_REF.exec(e))?this.createFunctionToken(this.createSheetRef(n,1),n[4],n[0]):(n=r.NAME_3D_REF.exec(e))?this._parseTableRef(e,this.createNameToken(this.createSheetRef(n,1),n[4],n[0])):(n=r.NAME_REF.exec(e))?this._parseTableRef(e,this.createNameToken(null,n[1],n[0])):this.grammar.UI&&(n=t.TABLE_OPEN.exec(e))?this._parseTableRef(e,null):void 0};var u=f.extend(function(e,t){f.call(this,e,t)});u.prototype.createSheetRangeData=function(e,t){return{r1:R.create(this.docModel,e[t+1],e[t+2],null,!!e[t]),r2:R.create(this.docModel,e[t+4],e[t+5],null,!!e[t+3])}},u.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null,n=null;return(r=t.RANGE_REF.exec(e))&&(n=this.createCellRangeRefs(r,1,5))?this.createReferenceToken(null,n,r[0]):(r=t.RANGE_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,5,9))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.RANGE_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,7,11))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.CELL_REF.exec(e))&&(n=this.createCellRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.CELL_3D_REF.exec(e))&&(n=this.createCellRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.CELL_CUBE_REF.exec(e))&&(n=this.createCellRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.COLS_REF.exec(e))&&(n=this.createColRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.COLS_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COLS_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,7,9))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.COL_REF.exec(e))&&(n=this.createColRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.COL_3D_REF.exec(e))&&(n=this.createColRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.COL_CUBE_REF.exec(e))&&(n=this.createColRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ROWS_REF.exec(e))&&(n=this.createRowRangeRefs(r,1,3))?this.createReferenceToken(null,n,r[0]):(r=t.ROWS_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,5,7))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROWS_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,7,9))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ROW_REF.exec(e))&&(n=this.createRowRangeRefs(r,1))?this.createReferenceToken(null,n,r[0]):(r=t.ROW_3D_REF.exec(e))&&(n=this.createRowRangeRefs(r,5))?this.createReferenceToken(this.createSheetRefs(r,1),n,r[0]):(r=t.ROW_CUBE_REF.exec(e))&&(n=this.createRowRangeRefs(r,7))?this.createReferenceToken(this.createSheetRangeData(r,1),n,r[0]):(r=t.ERROR_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),null,r[0]):(r=t.ERROR_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRangeData(r,1),null,r[0]):void 0},u.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(null,r[1],r[0]):(r=t.NAME_REF.exec(e))?this.createNameToken(null,r[1],r[0],{resolveTable:!0}):void 0};var T=f.extend(function(e,t){f.call(this,e,t)});T.prototype.parseNextRefToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.CELL_REF.exec(e))?this.createReferenceToken(null,this.createCellRangeRefs(r,1),r[0]):(r=t.CELL_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),this.createCellRangeRefs(r,5),r[0]):(r=t.RANGE_REF.exec(e))?this.createReferenceToken(null,this.createCellRangeRefs(r,1,5),r[0]):(r=t.RANGE_3D_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1),this.createCellRangeRefs(r,5,9),r[0]):(r=t.RANGE_CUBE_REF.exec(e))?this.createReferenceToken(this.createSheetRefs(r,1,9),this.createCellRangeRefs(r,5,13),r[0]):void 0},T.prototype.parseNextNameToken=function(e){var t=this.refGrammar.RE,r=null;return(r=t.FUNCTION_REF.exec(e))?this.createFunctionToken(null,r[1],r[0]):(r=t.NAME_REF.exec(e))?this.createNameToken(null,r[1],r[0],{resolveTable:!0}):void 0};var p={};return p.create=function(t,r){var n=t.getFormulaGrammar(r);switch(n.REF_SYNTAX){case l.OOX:return new E(t,n);case l.ODF_UI:return new u(t,n);case l.OF:return new T(t,n)}e.error('ExpressionParser.create(): invalid reference syntax: "'+n.REF_SYNTAX+'"')},p});