define("io.ox/office/spreadsheet/model/model",["io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/iterators","io.ox/office/tk/locale/locale","io.ox/office/editframework/model/viewattributesmixin","io.ox/office/textframework/utils/dom","io.ox/office/textframework/model/editor","io.ox/office/textframework/model/listhandlermixin","io.ox/office/textframework/model/updatelistsmixin","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/addressfactory","io.ox/office/spreadsheet/model/operationcontext","io.ox/office/spreadsheet/model/operationgenerator","io.ox/office/spreadsheet/model/numberformatter","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/sortlistcollection","io.ox/office/spreadsheet/model/sheetmodel","io.ox/office/spreadsheet/model/modelattributesmixin","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/updatetask","io.ox/office/spreadsheet/model/formula/parser/formulagrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/interpret/formulacompiler","io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter","io.ox/office/spreadsheet/model/formula/deps/dependencymanager"],function(e,t,n,r,i,o,a,s,l,h,c,u,p,d,g,f,m,E,S,C,v,O,y,A,T,I,R,x,N){"use strict";var M=t.isBoolean,w=n.clamp,D=n.createDict,b=r.arrayForEachReverse,L=r.arraySome,F=r.ValueSet,H=r.UidSet,G=r.ValueMap,k=i.ArrayIterator,V=o.LOCALE,U=u.MAX_SHEET_COUNT,P=u.getDebugFlag,B=u.setDebugFlag,K=d.SheetType,W=d.Range3DArray,j=d.modelLogger,X=g.AddressFactory,Y=f.SheetOperationContext,z=m.resolveOperations,q=m.SheetOperationGenerator,J=y.GrammarType,Q=A.DeleteSheetUpdateTask,Z=A.RenameSheetUpdateTask,ee=T.FormulaGrammarFactory,te=R.FormulaCompiler,ne={activeSheet:{def:-1,validate:function(t){return t>=-1&&t<this.getSheetCount()?t:e.BREAK}},rcStyle:{def:!1}},re={"change:attributes":"change:sheet:attributes","change:viewattributes":"change:sheet:viewattributes"},ie=D([p.SET_ATTRIBUTES,p.DELETE,p.MOVE,p.TEXT_INSERT,p.TAB_INSERT,p.HARDBREAK_INSERT,p.PARA_INSERT,p.PARA_SPLIT,p.PARA_MERGE,p.INSERT_LIST,p.DELETE_LIST],!0),oe=l.extend({constructor:j.profileMethod("SpreadsheetModel.constructor()",function(t,n){function r(e){return(e=_.isNumber(e)?e:_.isString(e)?D.getSheetIndex(e):-1)>=0&&e<ee.length?ee[e]:null}function i(e,t){var n=D.getSheetModel(e),r=_.isNumber(t)?D.getSheetModel(t):null;return 0===e.length?"sheet:name:empty":/^'|[\x00-\x1f\x80-\x9f[\]*?:/\\]|'$/.test(e)?"sheet:name:invalid":!_.isObject(n)||_.isObject(r)&&n===r?null:"sheet:name:used"}function o(e,t){return null===i(e,t)}function u(e,t){var n=i(e,t);return null===n?$.when():d.makeRejected(n)}function g(e,t,n,r){if(!D.canInsertSheet())return null;D.trigger("insert:sheet:before",e);var i=D.getActiveSheet();(i=e<=i?i+1:-1)>=0&&D.setActiveSheet(-1);var o=new v(D,t,r),a=o.uid,s=o.drawingCollection.getContainerNode();ee.splice(e,0,{model:o,uid:a,name:n,node:s}),he.insertBefore(s,he.childNodes.item(e)),e===ee.length?oe.insert(a,e):oe.clear(),i>=0&&D.setActiveSheet(i),D.trigger("insert:sheet:after",e,o);var l=_.times(ee.length-1,function(t){return t<e?t:t+1});return D.trigger("transform:sheets",l),D.listenTo(o,"triggered",function(e,t){var n=re[t]||t;D.trigger.apply(D,[n,o.getIndex()].concat(_.toArray(arguments).slice(2)))}),o}function f(e,t,n){D.registerContextOperationHandler(e,function(e){t[n](e)})}function m(t,n,r){var i=e.getBooleanOption(r,"allowDoc",!1);return D.registerContextOperationHandler(t,function(e){var t=i&&!e.has("sheet"),r=t?null:e.getInt("sheet"),o=t?D:D.getSheetModel(r);return e.ensure(o,"missing sheet"),n.call(D,e,o,r)})}function y(e,t,n,r){m(e,function(e,r){r[t][n](e)},r)}function A(e,t){return D.registerContextOperationHandler(e,function(e){var n=e.getPos("start");e.ensure(n.length>=2,"invalid drawing start position");var r=D.getSheetModel(n[0]);return e.ensure(r,"invalid sheet index"),t.call(D,e,r.drawingCollection,n.slice(1))})}function T(e,t){A(e,function(e,n,r){n[t](e,r)})}function R(t,n,r){var i=e.getStringOption(r,"type",null);A(t,function(e,t,r){var o=t.getModelDescriptor(r);e.ensure(o,"invalid drawing position"),e.ensure(!i||i===o.model.getType(),"invalid drawing type"),e.ensure(0===o.remaining.length,"invalid drawing start position"),o.model[n](e)})}var D=this,V=t.getFileFormat(),ee=[],oe=new G,ae=new F(function(e){return e.getKey()}),se=[],le=null,he=null;l.call(this,t,{contextClass:Y,defaultStyleFamily:"cell",slideMode:!0}),a.call(this,ne),h.call(this,t),c.call(this,t);var ce=this.createDebouncedMethod("SpreadsheetModel.sendActiveSelectionDebounced",null,function(){var e=D.getSelectionState();e&&t.updateUserData({sheet:e.sheet,ranges:D.formulaParser.formatRangeList(J.OP,e.selection.ranges),drawings:e.selection.drawings})},{delay:250});this.postProcessImport=function(){return 0===ee.length?$.Deferred().reject():(this.getCellStyles().createMissingStyles(),this.iterateArraySliced(ee,function(e){return e.model.postProcessImport()},"SpreadsheetModel.postProcessImport"))},this._registerTableModel=function(e){e.isAutoFilter()||ae.insert(e)},this._unregisterTableModel=function(e){e.isAutoFilter()||ae.remove(e)},this.getSelectionState=function(){var e=this.getActiveSheet(),t=this.getSheetModel(e);return t?{sheet:e,selection:t.getViewAttribute("selection")}:void 0},this.setSelectionState=function(e){var t=this.getSheetModel(e.sheet);t&&(this.setActiveSheet(e.sheet),t.setViewAttribute("selection",e.selection))},this.getFormulaGrammarOP=function(){return n.getGrammar(J.OP)},this.getFormulaGrammarUI=function(){var e=this.getViewAttribute("rcStyle");return n.getGrammar(e?J.UI_RC:J.UI_A1)},this.getFormulaGrammar=function(e){return e===J.UI?this.getFormulaGrammarUI():n.getGrammar(e)},this.getMaxCol=function(){return this.addressFactory.maxCol},this.getMaxRow=function(){return this.addressFactory.maxRow},this.getMaxIndex=function(e){return this.addressFactory.getMaxIndex(e)},this.getSheetRange=function(){return this.addressFactory.getSheetRange()},this.isColRange=function(e){return this.addressFactory.isColRange(e)},this.makeColRange=function(e){return this.addressFactory.getColRange(e)},this.makeColRanges=function(e){return this.addressFactory.getColRangeList(e)},this.isRowRange=function(e){return this.addressFactory.isRowRange(e)},this.makeRowRange=function(e){return this.addressFactory.getRowRange(e)},this.makeRowRanges=function(e){return this.addressFactory.getRowRangeList(e)},this.isFullRange=function(e,t){return this.addressFactory.isFullRange(e,t)},this.makeFullRange=function(e,t){return this.addressFactory.getFullRange(e,t)},this.makeFullRanges=function(e,t){return this.addressFactory.getFullRangeList(e,t)},this.isValidAddress=function(e){return this.addressFactory.isValidAddress(e)},this.getMaxSheetNameLength=function(){return t.isOOXML()?31:65535},this.hasSheet=function(e){return null!==r(e)},this.getSheetName=function(e){var t=r(e);return t?t.name:null},this.getSheetIndex=function(e){return e=e.toLowerCase(),_.findIndex(ee,function(t){return t.name.toLowerCase()===e})},this.getSheetIndexOfModel=function(e){var t=_.isString(e)?e:e.uid;return oe.getOrCreate(t,function(){return _.findIndex(ee,function(e){return e.uid===t})})},this.getSheetModel=function(e){var t=r(e);return t?t.model:null},this.getSheetCount=function(e){var t=e&&e.supported,n=e&&e.cells,r=e&&e.visible;return t||n||M(r)?this.createSheetIterator({supported:t,cells:n,visible:r}).reduce(0,function(e){return e+1}):ee.length},this.createSheetIterator=function(t){var n=e.getIntegerOption(t,"first",0),r=e.getIntegerOption(t,"last",ee.length-1),i=t&&t.reverse,o=new k(ee,{begin:i?r:n,end:i?n-1:r+1,reverse:i}),a=t&&t.supported,s=t&&t.cells,l=t&&t.visible,h=0;return o.mapIterator(function(e,t){var n=e.model;return a&&!n.isSupportedType()?null:s&&!n.isCellType()?null:M(l)&&l!==n.isVisible()?null:(t={value:n,name:e.name,sheet:t.index,index:h},h+=1,t)})},this.findVisibleSheet=function(e,t){var n=function(){switch(t){case"next":return{first:e,supported:!0,visible:!0};case"prev":return{last:e,reverse:!0,supported:!0,visible:!0}}return null}();if(n){var r=this.createSheetIterator(n).next();return r.done?-1:r.sheet}var i=this.findVisibleSheet(e,"next");return i<0?this.findVisibleSheet(e,"prev"):i},this.getActiveSheet=function(){return this.getViewAttribute("activeSheet")},this.setActiveSheet=function(e){j.takeTime("activating sheet "+e,function(){D.setViewAttribute("activeSheet",e)})},this.canInsertSheet=function(){return U<1||ee.length<U},this.generateUnusedSheetName=function(){for(var e="",t=ee.length;0===e.length||this.hasSheet(e);)e=d.getSheetName(t),t+=1;return e},this.hasUnsavedComments=function(){return ee.some(function(e){return e.model.hasUnsavedComment()})},this.discardUnsavedComments=function(){ee.forEach(function(e){e.model.discardUnsavedComment()})},this.hasName=function(e){return this.nameCollection.hasName(e)||ee.some(function(t){return t.model.nameCollection.hasName(e)})},this.getAllNames=function(t){var n=this.nameCollection.getAllNames(t);return e.getBooleanOption(t,"skipLocal",!1)||ee.forEach(function(e){n=n.concat(e.model.nameCollection.getAllNames(t))}),n},this.hasTable=function(e){return ae.hasKey(d.getTableKey(e))},this.getTable=function(e){return ae.get(d.getTableKey(e),null)},this.getAllTables=function(e){return ee.reduce(function(t,n){return t.concat(n.model.tableCollection.getAllTables(e))},[])},this.getRangeContents=function(t,n){var r=e.getIntegerOption(n,"maxCount",null,1),i=[],o=0;return t=W.filter(t,function(t){return!(!this.hasSheet(t.sheet1)||!t.singleSheet())||(e.warn("SpreadsheetModel.getRangeContents(): invalid sheet index in range address"),!1)},this),n=_.clone(n),L(t,function(e){var t=this.getSheetModel(e.sheet1).cellCollection,a=e.toRange(),s=t.getRangeContents(a,n);if(i=i.concat(s),o+=s.count,r===o)return!0;r&&(n.maxCount-=s.count)},this),i.count=o,i},this.sendOperations=_.wrap(this.sendOperations,function(e,t,n){return n&&n.defer?(se=se.concat(z(t,n)),!0):e.call(this,t,n)}),this.createAndApplyOperations=_.wrap(this.createAndApplyOperations,function(e,t,n){return se.length>0&&(this.sendOperations(se),se=[]),e.call(this,t,n)}),this.createSheetOperationGenerator=function(e){return new q(this,e)},this.createAndApplySheetOperations=j.profileMethod("SpreadsheetModel.createAndApplySheetOperations()",function(e,t){return t=_.extend({applyImmediately:!0,undoOptions:{preventSelectionChange:!0}},t,{generatorClass:q}),this.createAndApplyOperations(function(t){return this.setBlockKeyboardEvent(!0),D.convertToPromise(e.call(this,t)).always(function(){D.setBlockKeyboardEvent(!1)})},t)}),this.generateOperationsForSheets=function(e,t,n){var r=e.getSheetIndex();return this.iterateArraySliced(t,function(t){return e.setSheetIndex(t),n.call(D,D.getSheetModel(t),t)},"SpreadsheetModel.generateOperationsForSheets").always(function(){e.setSheetIndex(r)})},this.generateOperationsForAllSheets=function(t,n,r){var i=t.getSheetIndex(),o=e.getIntegerOption(r,"skipSheet",null);return this.iterateSliced(this.createSheetIterator(r),function(e,r){if(r.sheet!==o)return t.setSheetIndex(r.sheet),n.call(D,e,r.sheet)},"SpreadsheetModel.generateOperationsForAllSheets").always(function(){t.setSheetIndex(i)})},this.generateUpdateFormulaOperations=j.profileMethod("SpreadsheetModel.generateUpdateFormulaOperations()",function(t,n,r){var i=e.getStringOption(r,"drawingMode",null);return e.invokeChainedAsync("only"===i?null:function(){return D.nameCollection.generateUpdateFormulaOperations(t,n)},function(){return D.generateOperationsForAllSheets(t,function(e){return e.generateUpdateFormulaOperations(t,n,i)},r)})}),this.generateInsertSheetOperations=function(e,t,n,r,i){return u(r).then(function(){var o={sheetName:r};n!==K.WORKSHEET&&(o.type=n),_.isObject(i)&&(o.attrs=i),e.setSheetIndex(t),e.generateSheetOperation(p.DELETE_SHEET,null,{undo:!0}),e.generateSheetOperation(p.INSERT_SHEET,o)})},this.generateDeleteSheetOperations=function(e,t){var n=new Q(t),r=this.generateUpdateFormulaOperations(e,n,{skipSheet:t});return(r=r.then(function(){return e.setSheetIndex(t),D.getSheetModel(t).generateRestoreOperations(e)})).done(function(){e.setSheetIndex(t),e.generateSheetOperation(p.DELETE_SHEET)})},this.generateMoveSheetOperations=function(e,t,n){return e.generateOperation(p.MOVE_SHEET,{sheet:n,to:t},{undo:!0,prepend:!0}),e.generateOperation(p.MOVE_SHEET,{sheet:t,to:n}),this.createResolvedPromise()},this.generateMoveSheetsOperations=function(e,t){var n=new Array(t.length);return t.forEach(function(e,t){n[e]=t}),e.generateOperation(p.MOVE_SHEETS,{sheets:n},{undo:!0}),e.generateOperation(p.MOVE_SHEETS,{sheets:t}),this.createResolvedPromise()},this.generateCopySheetOperations=function(e,t,n,r){return u(r).then(function(){var i={};D.getAllTables().forEach(function(e){i[e.getKey()]=!0});var o=D.getSheetModel(t),a={};o.tableCollection.getAllTables().forEach(function(e){for(var t=e.getName(),n=/^(.*?)(\d+)$/.exec(t),r=n?n[1]:d.getTableName(),o=n?parseInt(n[2],10)+1:1;d.getTableKey(r+o)in i;)o+=1;var s=r+o;i[d.getTableKey(s)]=!0,a[t]=s});var s={to:n,sheetName:r};_.isEmpty(a)||(s.tableNames=a),e.setSheetIndex(t).generateSheetOperation(p.COPY_SHEET,s);var l=D.getSheetModel(n),h=new Z(t,r,a);e.setSheetIndex(n);var c=o.drawingCollection.createModelIterator({deep:!0,reverse:!0}),u=D.iterateSliced(c,function(t){"chart"!==t.getType()||t.isRestorable()||e.generateDrawingOperation(p.DELETE_DRAWING,t.getPosition())},"SpreadsheetModel.generateCopySheetOperations");return(u=u.then(function(){return l.generateUpdateFormulaOperations(e,h)})).done(function(){e.clearOperations({undo:!0}),e.generateSheetOperation(p.DELETE_SHEET,null,{undo:!0})})})},this.generateRenameSheetOperations=function(e,t,n){var r=this.getSheetName(t);return r===n?this.createResolvedPromise():u(n,t).then(function(){var i=new q(D),o=new Z(t,n);return D.generateUpdateFormulaOperations(i,o).done(function(){e.setSheetIndex(t),e.generateSheetOperation(p.CHANGE_SHEET,{sheetName:r},{undo:!0}),e.generateSheetOperation(p.CHANGE_SHEET,{sheetName:n}),e.appendOperations(i,{undo:!0}),e.appendOperations(i)})})},this.generateChangedViewAttributeOperations=function(e){var t=this.getActiveSheet();return t!==this.getDocumentAttribute("activeSheet")&&e.generateDocAttrsOperation({activeSheet:t}),this.createSheetIterator().forEach(function(t,n){var r=t.getChangedViewAttributes();_.isEmpty(r)||(e.setSheetIndex(n.sheet),t.generateChangeSheetOperations(e,{sheet:r}))}),this},this.addressFactory=new X(1,1),this.numberFormatter=new E(this),this.formulaResource=n.getResource(J.UI),this.formulaParser=new I(this),this.formulaCompiler=new te(this),this.formulaInterpreter=new x(this),this.nameCollection=new S(this),this.sortListCollection=new C(this),this.dependencyManager=new N(this),O.call(this),le=this.getNode()[0],(he=s.getPageContentNode(le)[0]).innerHTML="","ooxml"===V&&(f(p.INSERT_NUMBER_FORMAT,this.numberFormatter,"applyInsertOperation"),f(p.DELETE_NUMBER_FORMAT,this.numberFormatter,"applyDeleteOperation")),this.registerContextOperationHandler(p.INSERT_SHEET,function(e){var t=e.getInt("sheet"),n=e.getStr("sheetName"),r=e.getOptEnum("type",K,K.WORKSHEET),i=e.getOptObj("attrs");P("spreadsheet:failing-import")&&(B("spreadsheet:failing-import",!1),e.error("debug mode: insert sheet fails")),e.ensure(t>=0&&t<=ee.length,"invalid sheet index"),e.ensure(o(n),"invalid sheet name");var a=g(t,r,n,i);e.ensure(a,"cannot create sheet")}),this.registerContextOperationHandler(p.MOVE_SHEETS,function(e){var t=e.getPos("sheets"),n=ee.length;e.ensure(t.length===n,"invalid length of transformation vector");var r=_.unique(_.sortBy(t),!0);e.ensure(r.length===n,"duplicate sheet indexes in transformation vector"),e.ensure(0===r[0]&&_.last(r)===n-1,"invalid sheet indexes in transformation vector"),D.trigger("move:sheets:before",t);var i=D.getActiveSheet(),o=t.indexOf(i);i!==o&&D.setActiveSheet(-1),(ee=_.times(n,function(e){return ee[t[e]]})).forEach(function(e){he.appendChild(e.node)}),oe.clear(),i!==o&&D.setActiveSheet(o),D.trigger("move:sheets:after",t),D.trigger("transform:sheets",t)}),m(p.DELETE_SHEET,function(e,t,n){e.ensure(ee.length>1,"cannot delete last sheet"),D.trigger("delete:sheet:before",n,t);var r=D.getActiveSheet();n<r||n===r&&r+1===ee.length?r-=1:r<n&&(r=-1),r>=0&&D.setActiveSheet(-1),n+1===ee.length?oe.remove(t.uid):oe.clear(),he.removeChild(ee[n].node),ee.splice(n,1),t.destroy(),r>=0&&D.setActiveSheet(D.findVisibleSheet(r)),D.trigger("delete:sheet:after",n);var i=_.times(ee.length+1,function(e){return e<n?e:e===n?null:e-1});D.trigger("transform:sheets",i)}),m(p.CHANGE_SHEET,function(e,t,n){var i=r(n),a=e.getOptStr("sheetName");a&&(e.ensure(o(a,n),"invalid sheet name"),i.name!==a&&(i.name=a,D.trigger("rename:sheet",n,a,t)));var s=e.getOptObj("attrs");s&&t.setAttributes(s)}),m(p.MOVE_SHEET,function(e,t,n){var r=e.getInt("to");e.ensure(r>=0&&r<=ee.length,"invalid target index");var i=_.range(0,ee.length);i.splice(n,1),i.splice(r,0,n),D.trigger("move:sheets:before",i);var o=D.getActiveSheet(),a=d.transformIndex(o,n,r);o!==a&&D.setActiveSheet(-1);var s=ee[n];ee.splice(n,1),ee.splice(r,0,s),he.removeChild(s.node),he.insertBefore(s.node,he.childNodes.item(r)),oe.clear(),o!==a&&D.setActiveSheet(a),D.trigger("move:sheets:after",i),D.trigger("transform:sheets",i)}),m(p.COPY_SHEET,function(e,t){var n=e.getInt("to");e.ensure(n>=0&&n<=ee.length,"invalid target index");var r=e.getStr("sheetName");e.ensure(o(r),"invalid sheet name");var i=g(n,t.getType(),r);e.ensure(i,"cannot create sheet"),i.applyCopySheetOperation(e,t)}),y(p.CHANGE_CELLS,"cellCollection","applyChangeCellsOperation"),y(p.INSERT_CELLS,"cellCollection","applyInsertCellsOperation"),y(p.DELETE_CELLS,"cellCollection","applyDeleteCellsOperation"),y(p.INSERT_HYPERLINK,"hyperlinkCollection","applyInsertHyperlinkOperation"),y(p.DELETE_HYPERLINK,"hyperlinkCollection","applyDeleteHyperlinkOperation"),y(p.MERGE_CELLS,"mergeCollection","applyMergeCellsOperation"),y(p.INSERT_COLUMNS,"colCollection","applyInsertOperation"),y(p.DELETE_COLUMNS,"colCollection","applyDeleteOperation"),y(p.CHANGE_COLUMNS,"colCollection","applyChangeOperation"),y(p.INSERT_ROWS,"rowCollection","applyInsertOperation"),y(p.DELETE_ROWS,"rowCollection","applyDeleteOperation"),y(p.CHANGE_ROWS,"rowCollection","applyChangeOperation"),y(p.INSERT_NAME,"nameCollection","applyInsertOperation",{allowDoc:!0}),y(p.DELETE_NAME,"nameCollection","applyDeleteOperation",{allowDoc:!0}),y(p.CHANGE_NAME,"nameCollection","applyChangeOperation",{allowDoc:!0}),y(p.INSERT_TABLE,"tableCollection","applyInsertOperation"),y(p.DELETE_TABLE,"tableCollection","applyDeleteOperation"),y(p.CHANGE_TABLE,"tableCollection","applyChangeOperation"),y(p.CHANGE_TABLE_COLUMN,"tableCollection","applyChangeColumnOperation"),y(p.INSERT_VALIDATION,"validationCollection","applyInsertOperation"),y(p.DELETE_VALIDATION,"validationCollection","applyDeleteOperation"),y(p.CHANGE_VALIDATION,"validationCollection","applyChangeOperation"),y(p.INSERT_CFRULE,"condFormatCollection","applyInsertOperation"),y(p.DELETE_CFRULE,"condFormatCollection","applyDeleteOperation"),y(p.CHANGE_CFRULE,"condFormatCollection","applyChangeOperation"),y(p.INSERT_COMMENT,"commentCollection","applyInsertCommentOperation"),y(p.DELETE_COMMENT,"commentCollection","applyDeleteCommentOperation"),y(p.CHANGE_COMMENT,"commentCollection","applyChangeCommentOperation"),y(p.MOVE_COMMENTS,"commentCollection","applyMoveCommentsOperation"),y(p.INSERT_THREADED_COMMENT,"threadedCommentCollection","applyInsertCommentOperation"),y(p.DELETE_THREADED_COMMENT,"threadedCommentCollection","applyDeleteCommentOperation"),y(p.CHANGE_THREADED_COMMENT,"threadedCommentCollection","applyChangeCommentOperation"),y(p.MOVE_THREADED_COMMENTS,"threadedCommentCollection","applyMoveCommentsOperation"),T(p.INSERT_DRAWING,"applyInsertDrawingOperation"),T(p.DELETE_DRAWING,"applyDeleteDrawingOperation"),T(p.MOVE_DRAWING,"applyMoveDrawingOperation"),R(p.CHANGE_DRAWING,"applyChangeOperation"),R(p.INSERT_CHART_DATASERIES,"applyInsertSeriesOperation",{type:"chart"}),R(p.DELETE_CHART_DATASERIES,"applyDeleteSeriesOperation",{type:"chart"}),R(p.CHANGE_CHART_DATASERIES,"applyChangeSeriesOperation",{type:"chart"}),R(p.DELETE_CHART_AXIS,"applyDeleteAxisOperation",{type:"chart"}),R(p.CHANGE_CHART_AXIS,"applyChangeAxisOperation",{type:"chart"}),R(p.CHANGE_CHART_GRID,"applyChangeGridOperation",{type:"chart"}),R(p.CHANGE_CHART_TITLE,"applyChangeTitleOperation",{type:"chart"}),R(p.CHANGE_CHART_LEGEND,"applyChangeLegendOperation",{type:"chart"}),this.waitForImport(function(){if(0!==ee.length){ee.forEach(function(e){e.model.initializeViewAttributes()});var e=w(this.getDocumentAttribute("activeSheet"),0,ee.length-1),t=this.findVisibleSheet(e);t>=0&&this.setActiveSheet(t)}},this),this.listenTo(this.nameCollection,"triggered",function(e,t){D.trigger.apply(D,[t,null].concat(_.toArray(arguments).slice(2)))}),this.addressFactory.updateSheetSize(this.getDocumentAttribute("cols"),this.getDocumentAttribute("rows")),this.on("change:attributes",function(e,t){D.addressFactory.updateSheetSize(t.cols,t.rows)}),this.on("change:sheet:attributes",function(e,t){var n=D.getActiveSheet();if(t===n&&!D.getSheetModel(t).isVisible()){var r=D.findVisibleSheet(n);r>=0&&D.setActiveSheet(r)}}),this.on("change:viewattributes",function(e,t){"activeSheet"in t&&ce()}),this.on("change:sheet:viewattributes",function(e,t,n){"selection"in n&&t===D.getActiveSheet()&&ce()}),this.on("operations:success",function(e,t){if(t.some(function(e){return e.name in ie})){var n=_.pluck(ee,"model"),r=new H;b(t,function(e){if(e.name in ie){var t=e.start;if(!_.isArray(t)||t.length<3)return;var i=n[t[0]];if(!i)return;var o=i.drawingCollection.getModelDescriptor(t.slice(1));if(!o||0===o.remaining.length)return;r.insert(o.model)}else switch(e.name){case p.INSERT_SHEET:n.splice(e.sheet,1);break;case p.DELETE_SHEET:n.splice(e.sheet,0,null);break;case p.MOVE_SHEET:n.splice(e.sheet,0,n.splice(e.to,1)[0]);break;case p.COPY_SHEET:n.splice(e.to,1)}}),r.forEach(function(e){e.getParentCollection().trigger("change:drawing:text",e)})}}),this.listenTo(le,"mousedown touchstart",function(){D.setActiveMouseDownEvent(!0)}),this.registerDestructor(function(){this.dependencyManager.disconnect(),ee.forEach(function(e){e.model.destroy()}),this.nameCollection.destroy(),this.sortListCollection.destroy(),this.formulaInterpreter.destroy(),this.formulaCompiler.destroy(),this.formulaParser.destroy(),this.dependencyManager.destroy(),this.numberFormatter.destroy(),ae.clear(),t=D=ee=oe=ae=null,le=he=null})})});return oe.create=j.profileMethod("SpreadsheetModel.create()",function(e){return ee.create(e.getFileFormat(),V).then(function(t){return new oe(e,t)})}),oe});