define("io.ox/office/spreadsheet/view/labels",["io.ox/office/tk/utils","io.ox/office/tk/algorithms","io.ox/office/baseframework/app/extensionregistry","io.ox/office/editframework/view/editlabels","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","gettext!io.ox/office/spreadsheet/main"],function(e,t,o,n,a,r,s,l){"use strict";var i=t.capitalizeFirst,c=a.stringifyCol,m=a.stringifyRow,d=_.extend({},n);return d.COL_ROW_HEADER_LABEL=l.pgettext("menu-title","Rows/Columns"),d.CELL_HEADER_LABEL=l.pgettext("menu-title","Cells"),d.DATA_HEADER_LABEL=l.pgettext("menu-title","Data"),d.FILTER_HEADER_LABEL=l.pgettext("menu-title","Filter"),d.SORT_HEADER_LABEL=l.pgettext("menu-title","Sort"),d.INSERT_SHEET_LABEL=l("Insert sheet"),d.RENAME_SHEET_LABEL=l("Rename sheet"),d.COPY_SHEET_LABEL=l("Copy sheet"),d.DELETE_SHEET_LABEL=l("Delete sheet"),d.UNPROTECT_SHEET_LABEL=l("Unprotect sheet"),d.PROTECT_SHEET_LABEL=l("Protect sheet"),d.SHOW_SHEET_LABEL=l("Show sheet"),d.HIDE_SHEET_LABEL=l("Hide sheet"),d.REORDER_SHEETS_LABEL=l("Reorder sheets"),d.UNHIDE_SHEETS_LABEL=l("Unhide sheets"),d.LINEBREAK_LABEL=l("Automatic word wrap"),d.FORMAT_PAINTER_LABEL=l("Format painter"),d.FUNCTION_CATEGORY_LABELS={complex:l.pgettext("function-category","Complex"),conversion:l.pgettext("function-category","Conversion"),database:l.pgettext("function-category","Database"),datetime:l.pgettext("function-category","Date and time"),engineering:l.pgettext("function-category","Engineering"),financial:l.pgettext("function-category","Financial"),information:l.pgettext("function-category","Information"),logical:l.pgettext("function-category","Logical"),math:l.pgettext("function-category","Math"),matrix:l.pgettext("function-category","Matrix"),reference:l.pgettext("function-category","Reference"),statistical:l.pgettext("function-category","Statistical"),text:l.pgettext("function-category","Text"),web:l.pgettext("function-category","Web")},d.CUSTOM_FORMAT_VALUE="\0",d.CUSTOM_FORMAT_LABEL=l.pgettext("format-code","Custom"),d.LINEBREAK_BUTTON_OPTIONS={icon:"docs-insert-linebreak",tooltip:d.LINEBREAK_LABEL,toggle:!0,dropDownVersion:{label:d.LINEBREAK_LABEL}},d.FORMAT_PAINTER_BUTTON_OPTIONS={icon:"docs-format-painter",tooltip:d.FORMAT_PAINTER_LABEL,toggle:!0,dropDownVersion:{label:d.FORMAT_PAINTER_LABEL}},d.SORT_ASC_BUTTON_OPTIONS={icon:"docs-sort-up",label:l.pgettext("sort","Ascending"),tooltip:l.pgettext("sort","Sort from smallest to largest value")},d.SORT_DESC_BUTTON_OPTIONS={icon:"docs-sort-down",label:l.pgettext("sort","Descending"),tooltip:l.pgettext("sort","Sort from largest to smallest value")},d.SORT_CUSTOM_BUTTON_OPTIONS={label:l.pgettext("sort","Custom"),tooltip:l.pgettext("sort","Settings for sorting")},d.CLEAN_OPTIONS={label:l("Clear contents")},d.FORMAT_CATEGORY_LIST=[{name:"standard",label:l.pgettext("number-format","General")},{name:"number",label:l.pgettext("number-format","Number")},{name:"currency",label:l.pgettext("number-format","Currency")},{name:"date",label:l.pgettext("number-format","Date")},{name:"time",label:l.pgettext("number-format","Time")},{name:"datetime",label:l.pgettext("number-format","Date and time")},{name:"percent",label:l.pgettext("number-format","Percentage")},{name:"scientific",label:l.pgettext("number-format","Scientific")},{name:"fraction",label:l.pgettext("number-format","Fraction")},{name:"text",label:l.pgettext("number-format","Text")},{name:"custom",label:l.pgettext("number-format","Custom")}],d.CALCULATING_LABEL=l("Calculating"),d.getColLabel=function(e){return l("Column %1$s",_.noI18n(c(e)))},d.getRowLabel=function(e){return l("Row %1$s",_.noI18n(m(e)))},d.getSeriesLabel=function(e){return l("Series %1$d",_.noI18n(e+1))},d.getColRowLabel=function(e,t){return t?d.getColLabel(e):d.getRowLabel(e)},d.getCategoryLabel=function(t){return t in d.FUNCTION_CATEGORY_LABELS?d.FUNCTION_CATEGORY_LABELS[t]:(e.error('SpreadsheetLabels.getCategoryLabel(): unknown function category: "'+t+'"'),_.noI18n(i(t)))},d.RESULT_MESSAGES={"sheet:name:empty":l("The sheet name must not be empty. Please enter a name."),"sheet:name:invalid":l("This sheet name contains invalid characters. Please ensure that the name does not contain / \\ * ? : [ or ], and does neither start nor end with an apostrophe."),"sheet:name:used":l("This sheet name is already used. Please enter another name."),"sheet:locked":l("You cannot use this command on a protected sheet."),"cols:selection":l("Please select only entire columns, or just some cells in the sheet."),"cols:overflow":l("It is not possible to modify more than %1$d columns at the same time.",_.noI18n(r.MAX_CHANGE_COLS_COUNT)),"rows:selection":l("Please select only entire rows, or just some cells in the sheet."),"rows:overflow":l("It is not possible to modify more than %1$d rows at the same time.",_.noI18n(r.MAX_CHANGE_ROWS_COUNT)),"cells:locked":l("Protected cells cannot be modified."),"cells:overflow":l("It is not possible to modify more than %1$d cells at the same time.",_.noI18n(r.MAX_FILL_CELL_COUNT)),"cells:pushoff":l("It is not possible to insert new cells because non-empty cells would be pushed off the end of the sheet."),"merge:overlap":l("Overlapping ranges cannot be merged."),"merge:overflow":l("It is not possible to merge more than %1$d ranges at the same time.",_.noI18n(r.MAX_MERGED_RANGES_COUNT)),"autofill:merge:overlap":l("Autofill over merged cells is not allowed."),"name:invalid":l("This name contains invalid characters. Please enter another name."),"name:address":l("A cell address cannot be used as name. Please enter another name."),"name:used":l("This name is already used. Please enter another name."),"table:multiselect":l("Table cannot be created on multiple cell ranges."),"table:overlap":l("Table cannot be created on another filtered range."),"table:move":l("Parts of a table cannot be moved."),"table:change":l("Parts of a table cannot be changed."),"table:header:change":l("The header cells of a table cannot be changed."),"autofilter:multiselect":l("Filter cannot be applied to multiple cell ranges."),"autofilter:overlap":l("Filter cannot be applied to another filtered range."),"autofilter:blank":l("Filtering cannot be performed on blank cells."),"autofilter:move":l("Parts of the filter cannot be moved."),"sort:multiselect":l("Sorting cannot be performed on multiple cell ranges."),"sort:blank":l("Sorting cannot be performed on blank cells."),"sort:overflow":l("Sorting cannot be performed on more than %1$d columns or rows.",_.noI18n(r.MAX_SORT_LINES_COUNT)),"sort:merge:overlap":l("Sorting over merged cells is not allowed."),"search:nothing":l("No results for your search."),"search:finished":l("No more results for your search."),"replace:nothing":l("Nothing to replace."),"formula:invalid":l("The formula contains an error."),"formula:matrix:change":l("Parts of a matrix formula cannot be changed."),"formula:matrix:insert":l("It is not possible to insert cells into a matrix formula."),"formula:matrix:delete":l("Parts of a matrix formula cannot be deleted."),"formula:matrix:size":l("It is not possible to insert a matrix formula with more than %1$d elements.",_.noI18n(s.MAX_MATRIX_SIZE)),"formula:matrix:merged":l("It is not possible to insert a matrix formula over merged cells."),"validation:source":l("No source data available for the drop-down list."),"copy:overflow":l("It is not possible to copy more than %1$d cells at the same time.",_.noI18n(r.MAX_FILL_CELL_COUNT)),"paste:overflow":l("It is not possible to paste more than %1$d cells at the same time.",_.noI18n(r.MAX_FILL_CELL_COUNT)),"paste:outside":l("It is not possible to paste outside of the valid sheet area."),"paste:locked":l("Pasting into protected cells is not allowed."),"paste:ranges:unfit":l("You cannot paste this here because the copy area and paste area are not the same size. Select just one cell in the paste area or an area that's the same size, and try pasting again."),"drop:unsupported":l("File type not supported."),"drawing:text:editing":o.DOM_TEXT_EDIT_ALERT,"drawing:insert:locked":l("Objects cannot be inserted into a protected sheet."),"drawing:delete:locked":l("Objects on a protected sheet cannot be deleted."),"drawing:change:locked":l("Objects on a protected sheet cannot be changed."),"comment:insert:locked":l("Comments cannot be inserted into a protected sheet."),"comment:delete:locked":l("Comments on a protected sheet cannot be deleted."),"comment:change:locked":l("Comments on a protected sheet cannot be changed."),"comment:search:finished":l("No more comments found."),"notes:search:finished":l("No more notes found."),"comment:search:docbeginning":l("The search continues from the beginning of this document.")},d});