define("io.ox/office/textframework/utils/textutils",["io.ox/office/tk/utils","io.ox/office/tk/utils/logger","io.ox/office/tk/render/rectangle","io.ox/office/editframework/utils/attributeutils","io.ox/office/textframework/utils/dom"],function(e,t,n,r,i){"use strict";function o(e){function t(e){return parseInt(e.getAttribute("layer-order"),10)}return e.sort(function(e,n){return t(e)-t(n)}),e}function a(e,t){return new s(e.left-t.marginLeft,e.top-t.marginTop,e.width+t.marginLeft+t.marginRight,e.height+t.marginTop+t.marginBottom)}var l=t.Logger,s=n.Rectangle,u=_.clone(e),f=new RegExp("[ᄀ-ᇿ|㄰-㆏|ꥠ-꥿|가-힯|ힰ-퟿]"),d=new l("office:log-textutils",{tag:"TEXT",tagColor:65280});u.DEFAULT_PAPER_FORMAT={en_US:"Letter",en_GB:"A4",de_DE:"A4",fr_FR:"A4",fr_CA:"Letter",es_ES:"A4",es_MX:"Letter",nl_NL:"A4",pl_PL:"A4",ja_JP:"A4",it_IT:"A4",zh_CN:"A4",zh_TW:"A4",hu_HU:"A4",sk_SK:"A4",cs_CZ:"A4",lv_LV:"A4",ro_RO:"A4",pt_BR:"Letter",sv_SE:"A4",da_DK:"A4",ru_RU:"A4",tr_TR:"A4"},u.MAC_COMPOSE_CHARS=["^","~","´","`"],u.NO_DRAWING_BACKGROUND={fill:{type:"none",color:null,color2:null,gradient:null,bitmap:null,pattern:null}},u.NO_SLIDE_BACKGROUND={fill:{type:null,color:null,color2:null,gradient:null,bitmap:null,pattern:null}},u.textLogger=d;var g={Letter:{width:21590,height:27940},A4:{width:21e3,height:29700}};return u.indexOfValuesInsideTextSpan=function(t,n,r,i){var o=!1,a=0;if(e.getBooleanOption(i,"reverse",!1)){for(;n>=0&&!_.contains(r,t[n]);)n--;o=n>=0}else{for(a=t.length;n<a&&!_.contains(r,t[n]);)n++;o=n<a}return o?n:-1},u.mergeSiblingTextSpans=function(t,n){var o=null,a=null,l=null;(o=(t=e.getDomNode(t))[n?"nextSibling":"previousSibling"])&&i.isTextSpan(t)&&i.isTextSpan(o)&&r.hasEqualElementAttributes(t,o)&&(a=t.firstChild.nodeValue,l=o.firstChild.nodeValue,t.firstChild.nodeValue=n?a+l:l+a,$(o).remove())},u.getCSSPositionFromPoint=function(e,t,n){if(!e)return null;var r=$("<span>").text("|"),o=$(e.node.parentNode),a=parseFloat(o.css("line-height")),l=n/100;0===e.offset?o.before(r):(i.isSpan(o)&&i.splitTextSpan(o,e.offset,{append:!0}),o.after(r));var s=(r.offset().top-t.offset().top)/l-a+r.outerHeight(),f=(r.offset().left-t.offset().left)/l;return r.remove(),e.offset>0&&u.mergeSiblingTextSpans(o,!0),{top:s,left:f}},u.getCSSRectangleFromPoints=function(e,t,n,r,i){var o,a=document.createRange();if(a.setStart(e.node,e.offset),t)a.setEnd(t.node,t.offset);else if(e.offset+1<=e.node.length)a.setEnd(e.node,e.offset+1);else if(!i&&e.node.length>0)a.setStart(e.node,e.offset-1),a.setEnd(e.node,e.offset),o={top:(o=a.getBoundingClientRect()).top,left:o.right,height:o.height,width:0};else{var l=e.node.nextSibling;if(l)a.setEnd(l,0);else{var s=$(e.node.parentNode).offset().left+$(e.node.parentNode).width()*r;o={top:$(e.node.parentNode).offset().top,left:s,height:$(e.node.parentNode).height()*r,width:0}}}return o=o||a.getBoundingClientRect(),{top:(o.top-n.offset().top)/r,left:(o.left-n.offset().left)/r,height:o.height/r,width:o.width/r}},u.intervalOverlapsInterval=function(e,t){return e.first<=t.last&&t.first<=e.last},u.removeFalsyItemsInArray=function(e){return _.filter(e,function(e){return e})},u.calculateUserId=function(e){return _.isNumber(e)?10*(e+123)-123:null},u.resolveUserId=function(e){return _.isNumber(e)?(e+123)/10-123:null},u.getCharacterAttributesFromEmptyTextSpan=function(e){var t=null,n=null;return i.isParagraphNode(e)&&(t=i.findFirstPortionSpan(e),i.isEmptySpan(t)&&"character"in r.getExplicitAttributeSet(t)&&(n=r.getExplicitAttributeSet(t).character)),n},u.canMergeNeighboringOperations=function(){function e(e){return _.isObject(e.attrs)&&_.isObject(e.attrs.changes)}function t(e){return e.attrs&&e.attrs.changes&&e.attrs.changes.inserted&&e.attrs.changes.inserted.author}function n(e,n){var r=t(e),i=t(n);return _.isString(r)&&_.isString(i)&&r===i&&1===_.keys(n.attrs).length}return function(t,r){return!("attrs"in r)&&!e(t)||n(t,r)}}(),u.getAllAbsoluteDrawingsOnNode=d.profileMethod("TextUtils.getAllAbsoluteDrawingsOnNode()",function(e){return o(e.find(">.textdrawinglayer >.drawing.absolute, >.marginalcontent>.p .drawing.absolute"))}),u.getAllAbsoluteDrawingsOnPage=d.profileMethod("TextUtils.getAllAbsoluteDrawingsOnPage()",function(e,t){var n=".drawing.absolute:not(.grouped)",r=">.textdrawinglayer >"+n+'[page-number="'+t+'"]',i=e.find(r),a=e.find(".page-break"),l=$(a[t-2]),s=$(a[t-1]),u=null;if(l.length&&s.length||(u=e.find(">.pagecontent").children()),l.length){if(l.parent().is(".p")){var f=l.nextAll().find(n);i=i.add(f),l=l.parent()}}else l=$(u[0]);if(s.length){if(s.parent().is(".p")){var d=s.prevAll().find(n);i=i.add(d),s=s.parent()}}else s=$(_.last(u));var g=l.nextUntil(s).add(l).add(s).find(n);return i=i.add(g),o(i)}),u.findAllIntersections=d.profileMethod("TextUtils.findAllIntersections()",function(t,n,r){var i=$(t),o=t.getBoundingClientRect(),l=e.getStringOption(r,"marginKey",null),u=[];return o=l&&i.data(l)?a(o,i.data(l)):s.from(o),_.each(n,function(e){if(e!==t){var n=e.getBoundingClientRect();l&&$(e).data(l)&&(n=a(n,$(e).data(l))),o.overlaps(n)&&u.push(e)}}),u}),u.sortDrawingsOrder=function(e,t){var n=0,i=-e.length-1;_.each(e,function(e,o){var a=r.getExplicitAttributes(e,"drawing");(n=a.anchorBehindDoc?"page"===a.anchorVertBase||"margin"===a.anchorVertBase||"bottomMargin"===a.anchorVertBase?0:i+o:t+o)!==e.style.zIndex&&(e.style.zIndex=n)})},u.handleParagraphIndex=function(t,n){function i(n){var r=_.isNumber(u.anchorVertOffset)?e.convertHmmToLength(u.anchorVertOffset,"px",1):null;return null!==r&&(r<0||r+$(n).height()>$(t).height())}function o(e){var t=$(e).prev();t.length>0&&t.hasClass("incZIndex")&&(t.removeClass("incZIndex"),t.addClass("doubleIncZIndex"))}function a(e){var t=$(e).prev();t.length>0&&t.hasClass("doubleIncZIndex")&&(t.removeClass("doubleIncZIndex"),t.addClass("incZIndex"))}function l(e){var t=$(e).next();return t.length>0&&(t.hasClass("incZIndex")||t.hasClass("doubleIncZIndex"))}function s(){d=!!u.anchorBehindDoc,$(t).removeClass(p),d||(c=l(t)),d&&_.isNumber(u.anchorVertOffset)&&u.anchorVertOffset>=0&&(h=!1),!d&&_.isNumber(u.anchorVertOffset)&&u.anchorVertOffset<0&&(h=!1),h&&$(t).addClass(d?"decZIndex":c?"doubleIncZIndex":"incZIndex"),d?a(t):h&&o(t)}var u=null,f=null,d=!1,g=!0,c=!1,h=!0,p="incZIndex decZIndex doubleIncZIndex";n&&"none"===(u=r.getExplicitAttributes(n,"drawing")).textWrapMode&&i(n)&&(s(),g=!1),g&&((f=$(t).children(".drawing:not(.inline)")).length&&_.find(f,function(e){return"none"===(u=r.getExplicitAttributes(e,"drawing")).textWrapMode&&i(e)})?s():($(t).removeClass(p),a(t)))},u.getPageNumber=d.profileMethod("TextUtils.getPageNumber()",function(t,n){var r=t.getAttribute("page-number"),i=t.parentNode.classList.contains("textdrawinglayer");return r&&!i&&(e.error("drawing has attribute page number, but is a paragraph oriented drawing!!!"),r=null,t.setAttribute("page-number",null)),r?r=parseInt(r,10):(r=n.getPageLayout().getPageNumber(t),i&&t.setAttribute("page-number",r)),r}),u.isHangulText=function(e){return f.test(e)},u.getPaperSizeByLocale=function(e){var t=u.DEFAULT_PAPER_FORMAT[e];return(t?g[t]:null)||g.A4},u.getEmptyDrawingBackgroundAttributes=function(){return _.copy(u.NO_DRAWING_BACKGROUND,!0)},u.getEmptySlideBackgroundAttributes=function(){return _.copy(u.NO_SLIDE_BACKGROUND,!0)},u.convertAppContentBoxToPageBox=function(e,t){var n=e.getView().getZoomFactor(),r=e.getModel().getNode().offset(),i=e.getView().getContentRootNode(),o=i.offset(),a=i.scrollLeft(),l=i.scrollTop(),s={};return s.left=Math.round((t.left-(r.left-o.left)-a)/n),s.top=Math.round((t.top-(r.top-o.top)-l)/n),s.width=Math.round(t.width/n),s.height=Math.round(t.height/n),s},u});